unit ImeChangeForm;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TImeChangeDlg = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    procedure ListBox1Click(Sender: TObject);
  private
    hkll: packed array [0..255] of HKL;
    { Private 錾 }
    procedure InitDlg;
  public
    procedure ExecuteDlg;
  end;

implementation

{$R *.dfm}

uses Registry;

procedure TImeChangeDlg.ExecuteDlg;
begin
  InitDlg;
  if self.ShowModal = mrOk then begin
    ActivateKeyboardLayout(hkll[ListBox1.ItemIndex],$100{KLF_SETFORPROCESS});
  end;
end;

procedure TImeChangeDlg.InitDlg;
const
  LayoutsListRegKey: WideString = '\SYSTEM\CurrentControlSet\Control\Keyboard Layouts\';
var
  i: integer;
  hklnum: integer;
  reg: TRegistry;
  ws1, ws2, ws3, ws4: WideString;
begin
  hklnum := GetKeyboardLayoutList(Length(hkll), hkll);
  reg := TRegistry.Create;
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    for i := 0 to hklnum - 1 do begin
      ws1 := IntToHex(hkll[i], 8);
      if reg.OpenKeyReadOnly(LayoutsListRegKey + ws1) then begin
        ws1 := reg.ReadString('Layout Text');
      end else begin
        ws2 := WideString(IntToHex(hkll[i] shr 16, 8));
        ws3 := WideString(IntToHex(hkll[i] and 65535, 8));
        //if Imm32IsIME(hkll[i]) then
        if reg.OpenKeyReadOnly(LayoutsListRegKey + ws2) then
          ws2 := reg.ReadString('Layout Text') else ws2 := '';
        if reg.OpenKeyReadOnly(LayoutsListRegKey + ws3) then
          ws3 := reg.ReadString('Layout Text') else ws3 := '';
        ws4 := ws2;
        if ws4 = '' then begin
          ws4 := ws3;
          if ws4 = '' then ws4 := ws1;
        end else begin
          if (ws3 <> '') and (ws3 <> ws2) then ws4 := ws4 + '/' + ws3;
        end;
        ws1 := ws4;
      end;
      if not Imm32IsIME(hkll[i]) then ws1 := ws1 +' (' + IntToHex(hkll[i], 8) + ')';
      ListBox1.Items.Add(ws1);
    end;
  finally
    reg.Free;
  end;
end;

procedure TImeChangeDlg.ListBox1Click(Sender: TObject);
begin
  Button1.Enabled := ListBox1.ItemIndex > -1;
end;

end.
 
