//OLE Drag & Drop ꂽ TEditor gR|[lg
//http://homepage3.nifty.com/~katsuhiko/
//TEditor̃hbOhbvR|ɕthOledd.pas̃NX𗘗p
//jR[hɍւĂ

unit DragDropClasses;

interface

uses Windows, Classes, ActiveX;

const
  FormatEtcTEXT: TFormatEtc = (
     cfFormat: CF_TEXT;
     ptd: nil;
     dwAspect: DVASPECT_CONTENT;
     lindex: -1;
     tymed: TYMED_HGLOBAL;
  );
  FormatEtcHDROP: TFormatEtc = (
     cfFormat: CF_HDROP;
     ptd: nil;
     dwAspect: DVASPECT_CONTENT;
     lindex: -1;
     tymed: TYMED_HGLOBAL;
  );
  FormatEtcUniTEXT: TFormatEtc = (
     cfFormat: CF_UNICODETEXT;
     ptd: nil;
     dwAspect: DVASPECT_CONTENT;
     lindex: -1;
     tymed: TYMED_HGLOBAL;
  );

type
  PFormatEtc = ^TFormatEtc;
  TFormatEtcArray = array[0..0] of TFormatEtc;

  TFormatEtcList = class(TList)
  private
    function GetFormat(Index: Integer): TFormatEtc;
    procedure SetFormat(Index: Integer; Value: TFormatEtc);
  public
    destructor Destroy; override;
    function Add(FormatEtc: TFormatEtc): Integer;
    procedure Assign(Source: TFormatEtcList);
    procedure Clear; override;
    property Formats[Index: Integer]: TFormatEtc read GetFormat write SetFormat;
  end;

  TFormatEtcListObject = class(TInterfacedObject)
  private
    FList: TFormatEtcList;
  public
    constructor Create;
    destructor Destroy; override;
    property FormatList: TFormatEtcList read FList;
  end;

  TEnumFormatEtc = class(TFormatEtcListObject, IEnumFormatEtc)
  protected
    FIndex: Integer;
  public
    // IEnumFormatEtc
    function Next(celt: Longint; out elt; pceltFetched: PLongint): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out enum: IEnumFormatEtc): HResult; stdcall;
  end;

  TDDString = class(TFormatEtcListObject, IDataObject)
  private
    FData: WideString;
  protected
    function GetMedium(const FormatEtc: TFormatEtc; var Medium: TStgMedium;
      CreateMedium: Boolean): HResult;  virtual;
  public
    constructor Create;
    property Text: WideString read FData write FData;
    // IDataObject
    function GetData(const formatetcIn: TFormatEtc; out medium: TStgMedium): HResult; stdcall;
    function GetDataHere(const formatetc: TFormatEtc; out medium: TStgMedium): HResult; stdcall;
    function QueryGetData(const formatetc: TFormatEtc): HResult; stdcall;
    function GetCanonicalFormatEtc(const formatetc: TFormatEtc;
      out formatetcOut: TFormatEtc): HResult; stdcall;
    function SetData(const formatetc: TFormatEtc; var medium: TStgMedium;
      fRelease: BOOL): HResult; stdcall;
    function EnumFormatEtc(dwDirection: Longint; out enumFormatEtc:
      IEnumFormatEtc): HResult; stdcall;
    function DAdvise(const formatetc: TFormatEtc; advf: Longint;
      const advSink: IAdviseSink; out dwConnection: Longint): HResult; stdcall;
    function DUnadvise(dwConnection: Longint): HResult; stdcall;
    function EnumDAdvise(out enumAdvise: IEnumStatData): HResult; stdcall;
  end;

  TDDSource = class (TInterfacedObject, IDropSource)
    function QueryContinueDrag(fEscapePressed: BOOL;
      grfKeyState: Longint): HResult; stdcall;
    function GiveFeedback(dwEffect: Longint): HResult; stdcall;
  end;

implementation

uses SysUtils;

{ TFormatEtcList }

destructor TFormatEtcList.Destroy;
begin
  Clear;
  inherited Destroy;
end;

function TFormatEtcList.Add(FormatEtc: TFormatEtc): Integer;
var
  P: PFormatEtc;
begin
  New(P);
  P.cfFormat := FormatEtc.cfFormat;
  P.ptd := FormatEtc.ptd;
  P.dwAspect := FormatEtc.dwAspect;
  P.lindex := FormatEtc.lindex;
  P.tymed := FormatEtc.tymed;
  Result := inherited Add(P);
end;

procedure TFormatEtcList.Assign(Source: TFormatEtcList);
var
  I: Integer;
begin
  Clear;
  if Source <> nil then
    for I := 0 to Source.Count - 1 do
      Add(Source.Formats[I]);
end;

procedure TFormatEtcList.Clear;
var
  I: Integer;
begin
  for I := 0 to Count - 1 do
    Dispose(PFormatEtc(Items[I]));
  inherited Clear;
end;

function TFormatEtcList.GetFormat(Index: Integer): TFormatEtc;
var
  P: PFormatEtc;
begin
  P := PFormatEtc(Items[Index]);
  Result.cfFormat := P.cfFormat;
  Result.ptd := P.ptd;
  Result.dwAspect := P.dwAspect;
  Result.lindex := P.lindex;
  Result.tymed := P.tymed;
end;

procedure TFormatEtcList.SetFormat(Index: Integer; Value: TFormatEtc);
var
  P: PFormatEtc;
begin
  P := PFormatEtc(Items[Index]);
  P.cfFormat := Value.cfFormat;
  P.ptd := Value.ptd;
  P.dwAspect := Value.dwAspect;
  P.lindex := Value.lindex;
  P.tymed := Value.tymed;
end;

{ TFormatEtcListObject }

constructor TFormatEtcListObject.Create;
begin
  inherited Create;
  FList := TFormatEtcList.Create;
end;

destructor TFormatEtcListObject.Destroy;
begin
  FList.Free;
  inherited Destroy;
end;

{ TEnumFormatEtc }

function TEnumFormatEtc.Next(celt: Longint; out elt; pceltFetched: PLongint): HResult; stdcall;
(*
  FormatList ێĂ TFormatEtc f[^ FIndex  celt 
  elt Ɋi[Belt  TFormatEtc ̔zł邱Ƃɒ
*)
var
  I: Integer;
begin
  I := 0;
  while (I < celt) and (FIndex <= FormatList.Count - 1) do
  begin
    TFormatEtcArray(elt)[I] := FormatList.Formats[FIndex];
    Inc(FIndex);
    Inc(I);
  end;
  // 擾oi[
  if pceltFetched <> nil then
    pceltFetched^ := I;
  if I = celt then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TEnumFormatEtc.Skip(celt: Longint): HResult; stdcall;
// celt CfbNXi߂
begin
  if celt <= FormatList.Count - FIndex then
  begin
    FIndex := FIndex + celt;
    Result := S_OK;
  end
  else
  begin
    FIndex := FormatList.Count;
    Result := S_FALSE;
  end;
end;

function TEnumFormatEtc.Reset: HResult; stdcall;
// FIndex 
begin
  FIndex := 0;
  Result := S_OK;
end;

function TEnumFormatEtc.Clone(out enum: IEnumFormatEtc): HResult; stdcall;
// 
var
  I: Integer;
begin
  enum := TEnumFormatEtc.Create;
  for I := 0 to FormatList.Count - 1 do
    TEnumFormatEtc(enum).FormatList.Add(FormatList.Formats[I]);
  Result := S_OK;
end;

{ TDDString }

constructor TDDString.Create;
begin
  inherited Create;
  FormatList.Add(FormatEtcTEXT);
  FormatList.Add(FormatEtcUniTEXT);
end;

function TDDString.DAdvise(const formatetc: TFormatEtc; advf: Integer;
  const advSink: IAdviseSink; out dwConnection: Integer): HResult;
begin
  Result := OLE_E_ADVISENOTSUPPORTED; // not support
end;

function TDDString.DUnadvise(dwConnection: Integer): HResult;
begin
  Result := OLE_E_ADVISENOTSUPPORTED; // not support
end;

function TDDString.EnumDAdvise(out enumAdvise: IEnumStatData): HResult;
begin
  Result := OLE_E_ADVISENOTSUPPORTED; // not support
end;

function TDDString.EnumFormatEtc(dwDirection: Integer;
  out enumFormatEtc: IEnumFormatEtc): HResult;
(*
  enumFormatEtc  IEnumFormatEtc ̎ւ̎QƂi[B
  IEnumFormatEtc  FormatList mȂ̂ŁAU TEnumFormatEtc ^
  ϐ TEnumFormatEtc ̃CX^Xi[AFormatList XV
   enumFormatEtc ɑB

  enumFormatEtc := TEnumFormatEtc.Create;
  TEnumFormatEtc(enumFormatEtc).FormatList.Assign(FormatList);

  ƃLXgŊyoARpCxĂAANZXᔽ
  B
*)
var
  Etc: TEnumFormatEtc;
begin
  Result := E_NOTIMPL;
  enumFormatEtc := nil;
  if dwDirection = DATADIR_GET then
  begin
    Etc := TEnumFormatEtc.Create;
    Etc.FormatList.Assign(FormatList);
    enumFormatEtc := Etc;
    Result := S_OK;
  end
end;

function TDDString.GetCanonicalFormatEtc(const formatetc: TFormatEtc;
  out formatetcOut: TFormatEtc): HResult;
begin
  formatetcOut := formatetc;
  formatetcOut.ptd := nil;
  Result := DATA_S_SAMEFORMATETC;
end;

function TDDString.GetData(const formatetcIn: TFormatEtc;
  out medium: TStgMedium): HResult;
begin
  // init
  Result := DV_E_FORMATETC;
  medium.tymed := 0;
  medium.hGlobal := 0;
  medium.UnkForRelease := nil;
  try
    // confirm & getdata
    if QueryGetData(formatetcIn) = S_OK then
      Result := GetMedium(formatetcIn, medium, True);
  except
    Result := E_UNEXPECTED;
  end;
end;

function TDDString.GetDataHere(const formatetc: TFormatEtc;
  out medium: TStgMedium): HResult;
begin
  Result := DV_E_FORMATETC;
  try
    // confirm & getdata
    if QueryGetData(formatetc) = S_OK then
      Result := GetMedium(formatetc, medium, False);
  except
    Result := E_UNEXPECTED;
  end;
end;

function TDDString.GetMedium(const FormatEtc: TFormatEtc;
  var Medium: TStgMedium; CreateMedium: Boolean): HResult;
var
  hMem: HGLOBAL;
  Buffer: Pointer;
  len: integer;
  i:integer;
begin

  if not CreateMedium then
  begin
    Result := E_NOTIMPL;
    Exit;
  end;
  if FormatEtc.cfFormat = CF_UNICODETEXT then begin
    len := Length(FData);
    hMem := GlobalAlloc(GHND, len * 2 + 2);
    if hMem <> 0 then begin
      Buffer := GlobalLock(hMem);
      for i := 0 to len - 1 do (PWChar(Buffer) + i)^ := (PWChar(FData) + i)^;
      GlobalUnlock(hMem);
      Medium.hGlobal := hMem;
      Medium.tymed   := FormatEtc.tymed;
      Result := S_OK;
    end else Result := STG_E_MEDIUMFULL;
  end else begin
    hMem := GlobalAlloc(GHND, Length(AnsiString(FData)) + 1);
    if hMem <> 0 then begin
      Buffer := GlobalLock(hMem);
      StrCopy(PAnsiChar(Buffer), PAnsiChar(AnsiString(Fdata)));
      GlobalUnlock(hMem);
      Medium.hGlobal := hMem;
      Medium.tymed   := FormatEtc.tymed;
      Result := S_OK;
    end else Result := STG_E_MEDIUMFULL;
  end;
end;

function TDDString.QueryGetData(const formatetc: TFormatEtc): HResult;
var
  I: Integer;
begin
  Result := DV_E_FORMATETC;
  for I := 0 to FormatList.Count - 1 do
    if (formatetc.cfFormat = FormatList.Formats[I].cfFormat) and
       (formatetc.dwAspect = FormatList.Formats[I].dwAspect) and
       (formatetc.tymed and FormatList.Formats[I].tymed <> 0) then
    begin
      Result := NOERROR;
      Break;
    end;
end;

function TDDString.SetData(const formatetc: TFormatEtc; var medium: TStgMedium;
  fRelease: BOOL): HResult;
begin
  Result := E_NOTIMPL; // not support
end;

{ TDDSource }

function TDDSource.GiveFeedback(dwEffect: Integer): HResult;
begin
  Result := DRAGDROP_S_USEDEFAULTCURSORS;
end;

function TDDSource.QueryContinueDrag(fEscapePressed: BOOL;
  grfKeyState: Integer): HResult;
begin
  if fEscapePressed or (grfKeyState and MK_RBUTTON = MK_RBUTTON) then
    // GXP[vL[ꂽA}EX̉E{^ꂽ
    Result := DRAGDROP_S_CANCEL
  else
    if grfKeyState and MK_LBUTTON = 0 then
      // }EX̍{^Ă
      Result := DRAGDROP_S_DROP
    else
      Result := S_OK;
end;

end.
