unit FontUtils;

interface

uses Windows, Graphics;

function GetFontCharSet(const Value: WideString): integer;
function GetGlyphWidth(const Value: WideChar): integer;
function GetGlyphAveWidth: integer;
procedure InitFontWidthMap(AFont: TFont; ABase: integer; AFixed: boolean);
function CC2String(const Value: WideChar): WideString;

const
//ɂΉĂȂ̂ŎdȂMSSVbNA
//^{̂̑̕lAftHgTahomaɂB
//łeLXgGfB^͂Ƃ肠Ȃ_낤ȁB
  DefaultFontName = 'lr SVbN';
  //DefaultFontName = 'Tahoma';

var
  FDefaultFont: TFont;

procedure UnitInitialize;

implementation

uses Math;

var
  FFontWidthMap: array [$0000 .. $FFFF] of Word;//65536pixȏ̉͂ȂˁH
  FFontBitmap : TBitmap;
  FAveWidth: integer;
  FFixed: boolean;

function GetFontCharSet(const Value: WideString): integer;
//Windows̓tHgCharSetD悷Ȃ̂ŁA
//TFontɂꂼ̃tHgZbg̈Ă邱ƂŁA
//KtHgŃtHgIł悤ɂȂB
  function GetFontCharSetProc(var EnumLogFont: TEnumLogFontExW;
    var NewTextMetric: TNewTextMetricExW; FontType: DWORD;
    Data: PInteger): Integer; stdcall;
  begin
    data^ := NewTextMetric.ntmTm.tmCharSet;
    Result := 0;
  end;

var
  lf: LOGFONTW;
  h: HDC;
begin
  lf.lfCharSet := DEFAULT_CHARSET;
  for Result := 1 to Length(lf.lfFaceName) do
    lf.lfFaceName[Result - 1] := #0;
  for Result := 1 to Length(Value) do
    lf.lfFaceName[Result - 1] := Value[Result];
  lf.lfPitchAndFamily := 0;
  Result := DEFAULT_CHARSET; //񋓎sl
  h := GetDC(0);
  try
    EnumFontFamiliesExW(h, lf, @GetFontCharSetProc, integer(@result), 0);
  finally
    ReleaseDC(0, h);
  end;
end;

function CC2String(const Value: WideChar): WideString;
const
  C0: array[$00..$20] of WideString = (
  'NUL', 'SOH', 'STH', 'ETX', 'EOT', 'ENQ', 'ACK', 'BEL',
  'BS', 'HT', 'LF', 'VT', 'FF', 'CR', 'SO', 'SI',
  'DLE', 'DC1', 'DC2', 'DC3', 'DC4', 'NAK', 'SYN', 'ETB',
  'CAN', 'EM', 'SUB', 'ESC', 'FS', 'GS', 'RS', 'US',
  'SP'
  );
  C1: array[$80..$A0] of WideString =(
  'XXX', 'XXX', 'BPH', 'NBH', 'IND', 'NEL', 'SSA', 'ESA',
  'HTS', 'HTJ', 'VTS', 'PLD', 'PLU', 'RI', 'SS2', 'SS3',
  'DCS', 'PU1', 'PU2', 'STS', 'CCH', 'MW', 'SPA', 'EPA',
  'SOS', 'XXX', 'SCI', 'CSI', 'ST', 'OSC', 'PM', 'APC',
  'NBSP'
  );
begin
  if word(Value) <= $20 then begin
    Result := '[' + C0[word(Value)] + ']';
    exit;
  end;
  if word(Value) <= $A0 then begin
    Result := '[' + C1[word(Value)] + ']';
    exit;
  end;
  Result := '[]';       
end;

function GetGlyphWidth(const Value: WideChar): integer;
var
  //W: array[0..0]of integer;
  p: TSize;
  ws: WideString;
begin
  if FFontWidthMap[Word(Value)] > 0 then Result := FFontWidthMap[Word(Value)]
  else begin
    if (Word(Value) <= $9F) and ((Word(Value) < $20) or (Word(Value) >= $80))  then begin
      ws := CC2String(Value);
      GetTextExtentPoint32W(FFontBitmap.Canvas.Handle, PWChar(ws), Length(ws), p);
    end else begin
      //OťvZ̎dčI
      //ۂTextOutƂƓŁAȂ̂͂ǂꂩH
      //GetCharWidth32ƁAOt𕡐ɏƂɃYႤ悤B
      //GetCharWidth32W(FFontBitmap.Canvas.Handle, Cardinal(Value), Cardinal(Value), W);
      //Result := Max(1,W[0]);
      //TextOut̕ƈv̂GetTextExtentPoint32
      GetTextExtentPoint32W(FFontBitmap.Canvas.Handle, @Value, 1, p);
    end;
    //[̏ꍇ悤B
    //A`lƕ̍Œl2hbgKvB
    //ȂlllllllllllƂ̓hԂɂȂĂ܂B
    Result := Max(2,p.cx);
    //WinXPȑO̓tHg1ȂԂƂ炵B
    //http://www.microsoft.com/japan/msdn/windows/windowsxp/FixedPitchFont.asp
    if FFixed and (Result = FAveWidth * 2 - 1) then inc(Result);
    FFontWidthMap[Word(Value)] := Result;
  end;
end;

function GetGlyphAveWidth: integer;
begin
  Result := FAveWidth;
end;

procedure InitFontWidthMap(AFont: TFont; ABase: integer; AFixed: boolean);
var
  i: integer;
begin
  for i := $0 to $FFFF do FFontWidthMap[i] := 0;
  FFontBitmap.Canvas.Font := AFont;
  FAveWidth := ABase;
  FFixed := AFixed;
end;

procedure UnitInitialize;
begin
  FDefaultFont := TFont.Create;
  FDefaultFont.Name := DefaultFontName;
  FDefaultFont.Size := 10;
  FFontBitmap := TBitmap.Create;
  InitFontWidthMap(FDefaultFont, 0, true);
end;

initialization
finalization
  if Assigned(FFontBitmap) then FFontBitmap.Free;
  if Assigned(FDefaultFont) then FDefaultFont.Free;
end.
