unit ModeUwsc;

interface

uses Windows, NotePadMode, NotePadString;

type
  TModeUwsc = class(TNotePadMode)
  protected
    procedure InitReserveList;override;
  public
    function NewParser(target: TNotePadString): TNotePadParser;override;
  end;

  TParserUwsc = class(TNotePadParser)
  private
  protected
    procedure ParseToken(AHttp: boolean);overload;override;
    procedure ParseToken(const C: WideChar);overload;override;
  public
    constructor Create(target: TNotePadString; mode: TModeUwsc);
  end;

implementation

uses NotePadClasses, ParserConsts;

const
  ss1: array[0..50] of WideString =(
'AND',
'BREAK',
'CALL',
'CASE',
'CLASS',
'CONST',
'CONTINUE',
'DEF_DLL',
'DEFAULT',
'DIM',
'ELSE',
'ELSEIF',
'ENDCLASS',
'ENDIF',
'ENDTEXTBLOCK',
'ENDTRY',
'ENDWITH',
'EXCEPT',
'EXIT',
'FEND',
'FINALLY',
'FOR',
'FUNCTION',
'GLOBAL',
'HASHTBL',
'IF',
'IFB',
'MOD',
'NEXT',
'OPTION',
'OR',
'PRINT',
'PROCEDURE',
'PUBLIC',
'REPEAT',
'RESULT',
'SELECT',
'SELEND',
'STEP',
'TEXTBLOCK',
'THEN',
'THIS',
'THREAD',
'TO',
'TRY',
'UNTIL',
'VAR',
'WEND',
'WHILE',
'WITH',
'XOR');

  ss2: array[0..114] of WideString =(
'ABS',
'ACW',
'ARCCOS',
'ARCSIN',
'ARCTAN',
'ASC',
'ASCB',
'BETWEENSTR',
'BTN',
'CEIL',
'CHGMOJ',
'CHKBTN',
'CHKIMG',
'CHKNUM',
'CHKSND',
'CHR',
'CHRB',
'CLKITEM',
'COM_ERR_IGN',
'COM_ERR_RET',
'COPY',
'COPYB',
'COS',
'CREATEFORM',
'CREATEOLEOBJ',
'CTRLWIN',
'DECODE',
'DELETEINI',
'DICTATE',
'DOSCMD',
'DROPFILE',
'ENCODE',
'EVAL',
'EXEC',
'EXP',
'FCLOSE',
'FDELLINE',
'FGET',
'FOPEN',
'FORMAT',
'FPUT',
'FUKIDASI',
'GETACTIVEOLEOBJ',
'GETALLWIN',
'GETCTLHND',
'GETDIR',
'GETFORMDATA',
'GETID',
'GETITEM',
'GETKEYSTATE',
'GETOLEITEM',
'GETSLCTLST',
'GETSTR',
'GETTIME',
'HNDTOID',
'IDTOHND',
'IEGETDATA',
'IEGETSRC',
'IELINK',
'IESETDATA',
'INPUT',
'INT',
'ISUNICODE',
'KBD',
'KINDOFOS',
'LENGTH',
'LENGTHB',
'LN',
'LOCKHARD',
'LOGN',
'LOGPRINT',
'MMV',
'MOUSEORG',
'MSGBOX',
'MUSCUR',
'OLEEVENT',
'PEEKCOLOR',
'POFF',
'POPUPMENU',
'POS',
'POSACC',
'POSB',
'POWER',
'RANDOM',
'READINI',
'RECOSTATE',
'REPLACE',
'RESIZE',
'ROUND',
'SAVEIMG',
'SCKEY',
'SENDSTR',
'SETCLEAR',
'SETFORMDATA',
'SETSLIDER',
'SIN',
'SLEEP',
'SOUND',
'SPEAK',
'SQRT',
'STATUS',
'STOPFORM',
'STRCONV',
'TAN',
'TOKEN',
'TRIM',
'VAL',
'WRITEINI',
'XLACTIVATE',
'XLCLOSE',
'XLGETDATA',
'XLOPEN',
'XLSETDATA',
'XLSHEET',
'ZCUT');

  ss3: array[0..106] of WideString =(
'VK_ACCEPT',
'VK_ADD',
'VK_ALT',
'VK_APPS',
'VK_BACK',
'VK_BROWSER_BACK',
'VK_BROWSER_FAVORITES',
'VK_BROWSER_FORWARD',
'VK_BROWSER_HOME',
'VK_BROWSER_REFRESH',
'VK_BROWSER_SEARCH',
'VK_BROWSER_STOP',
'VK_CAPITAL',
'VK_CLEAR',
'VK_CONTROL',
'VK_CONVERT',
'VK_CTRL',
'VK_DECIMAL',
'VK_DELETE',
'VK_DIVIDE',
'VK_DOWN',
'VK_END',
'VK_ESC',
'VK_ESCAPE',
'VK_EXECUTE',
'VK_F1',
'VK_F10',
'VK_F11',
'VK_F12',
'VK_F2',
'VK_F3',
'VK_F4',
'VK_F5',
'VK_F6',
'VK_F7',
'VK_F8',
'VK_F9',
'VK_FINAL',
'VK_HELP',
'VK_HOME',
'VK_INSERT',
'VK_KANA',
'VK_KANJI',
'VK_LAUNCH_APP1',
'VK_LAUNCH_APP2',
'VK_LAUNCH_MAIL',
'VK_LAUNCH_MEDIA_SELECT',
'VK_LEFT',
'VK_MEDIA_NEXT_TRACK',
'VK_MEDIA_PLAY_PAUSE',
'VK_MEDIA_PREV_TRACK',
'VK_MEDIA_STOP',
'VK_MENU',
'VK_MODECHANGE',
'VK_MULTIPLY',
'VK_NEXT',
'VK_NONCONVERT',
'VK_NUMLOCK',
'VK_NUMPAD0',
'VK_NUMPAD1',
'VK_NUMPAD2',
'VK_NUMPAD3',
'VK_NUMPAD4',
'VK_NUMPAD5',
'VK_NUMPAD6',
'VK_NUMPAD7',
'VK_NUMPAD8',
'VK_NUMPAD9',
'VK_OEM_1',
'VK_OEM_2',
'VK_OEM_3',
'VK_OEM_4',
'VK_OEM_5',
'VK_OEM_6',
'VK_OEM_7',
'VK_OEM_8',
'VK_OEM_COMMA',
'VK_OEM_JUMP',
'VK_OEM_MINUS',
'VK_OEM_PA1',
'VK_OEM_PA2',
'VK_OEM_PA3',
'VK_OEM_PERIOD',
'VK_OEM_PLUS',
'VK_OEM_RESET',
'VK_PAUSE',
'VK_PRINT',
'VK_PRIOR',
'VK_RCTRL',
'VK_RETURN',
'VK_RIGHT',
'VK_RSHIFT',
'VK_SCROLL',
'VK_SELECT',
'VK_SEPARATOR',
'VK_SHIFT',
'VK_SLEEP',
'VK_SNAPSHOT',
'VK_SPACE',
'VK_START',
'VK_SUBTRACT',
'VK_TAB',
'VK_UP',
'VK_VOLUME_DOWN',
'VK_VOLUME_MUTE',
'VK_VOLUME_UP',
'VK_WIN');

type
  THash1 = class(THashTable)
  protected
    procedure InitTable; override;
  public
    function isReserbed(const Value: WideString): boolean; override;
  end;


{ THash1 }

procedure THash1.InitTable;
var
  aa1: array of word;
  i, j: integer;
begin
  FSize := 103;{}
  FMaxLen := 1;
  SetLength(aa1, Length(ss1{}));
  for i := 0 to  Length(aa1) - 1 do begin
    aa1[i] := AnkToHash(ss1{}[i]);
    if Length(ss1{}[i]) > FMaxLen then FMaxLen := Length(ss1{}[i]);
  end;
  SetLength(FTable, FSize);
  for i := 0 to  Length(FTable) - 1 do begin
    FTable[i] := 0;
  end;
  for i := 0 to  Length(aa1) - 1 do begin
    j := aa1[i];
    while FTable[j] > 0 do begin
      inc(j);
      if j >= Length(FTable) then dec(j, Length(FTable) - 1);
    end;
    FTable[j] := i + 1;
  end;
end;

function THash1.isReserbed(const Value: WideString): boolean;
var
  i: integer;
begin
  Result := false;
  if Length(Value) > FMaxLen then exit;
  i := AnkToHash(Value);
  while FTable[i] > 0 do begin
    if ss1{}[FTable[i] - 1] = Value then begin
      Result := true;
      exit;
    end;
    inc(i);
    if i >= FSize then dec(i, FSize);
  end;
end;

type
  THash2 = class(THashTable)
  protected
    procedure InitTable; override;
  public
    function isReserbed(const Value: WideString): boolean; override;
  end;

{ THash2 }

procedure THash2.InitTable;
var
  aa1: array of word;
  i, j: integer;
begin
  FSize := 233;{}
  FMaxLen := 1;
  SetLength(aa1, Length(ss2{}));
  for i := 0 to  Length(aa1) - 1 do begin
    aa1[i] := AnkToHash(ss2{}[i]);
    if Length(ss2{}[i]) > FMaxLen then FMaxLen := Length(ss2{}[i]);
  end;
  SetLength(FTable, FSize);
  for i := 0 to  Length(FTable) - 1 do begin
    FTable[i] := 0;
  end;
  for i := 0 to  Length(aa1) - 1 do begin
    j := aa1[i];
    while FTable[j] > 0 do begin
      inc(j);
      if j >= Length(FTable) then dec(j, Length(FTable) - 1);
    end;
    FTable[j] := i + 1;
  end;
end;

function THash2.isReserbed(const Value: WideString): boolean;
var
  i: integer;
begin
  Result := false;
  if Length(Value) > FMaxLen then exit;
  i := AnkToHash(Value);
  while FTable[i] > 0 do begin
    if ss2{}[FTable[i] - 1] = Value then begin
      Result := true;
      exit;
    end;
    inc(i);
    if i >= FSize then dec(i, FSize);
  end;
end;

type
  THash3 = class(THashTable)
  protected
    procedure InitTable; override;
  public
    function isReserbed(const Value: WideString): boolean; override;
  end;


{ THash3 }

procedure THash3.InitTable;
var
  aa1: array of word;
  i, j: integer;
begin
  FSize := 223;{}
  FMaxLen := 1;
  SetLength(aa1, Length(ss3{}));
  for i := 0 to  Length(aa1) - 1 do begin
    aa1[i] := AnkToHash(ss3{}[i]);
    if Length(ss3{}[i]) > FMaxLen then FMaxLen := Length(ss3{}[i]);
  end;
  SetLength(FTable, FSize);
  for i := 0 to  Length(FTable) - 1 do begin
    FTable[i] := 0;
  end;
  for i := 0 to  Length(aa1) - 1 do begin
    j := aa1[i];
    while FTable[j] > 0 do begin
      inc(j);
      if j >= Length(FTable) then dec(j, Length(FTable) - 1);
    end;
    FTable[j] := i + 1;
  end;
end;

function THash3.isReserbed(const Value: WideString): boolean;
var
  i: integer;
begin
  Result := false;
  if Length(Value) > FMaxLen then exit;
  i := AnkToHash(Value);
  while FTable[i] > 0 do begin
    if ss3{}[FTable[i] - 1] = Value then begin
      Result := true;
      exit;
    end;
    inc(i);
    if i >= FSize then dec(i, FSize);
  end;
end;

var
  FHash1: THash1;
  FHash2: THash2;
  FHash3: THash3;

type
  TUwscList = class(TReserveList)
  public
    function Find(const s: WideString): boolean; override;
  end;

{ TUwscList }

function TUwscList.Find(const s: WideString): boolean;
begin
  Result := FHash1.isReserbed(s);
end;

type
  TUwsc2List = class(TReserveList)
  public
    function Find(const s: WideString): boolean; override;
  end;

{ TUwsc2List }

function TUwsc2List.Find(const s: WideString): boolean;
begin
  Result := FHash2.isReserbed(s);
end;

type
  TUwsc3List = class(TReserveList)
  public
    function Find(const s: WideString): boolean; override;
  end;

{ TUwsc3List }

function TUwsc3List.Find(const s: WideString): boolean;
begin
  Result := FHash3.isReserbed(s);
end;

{ TModeUwsc }

procedure TModeUwsc.InitReserveList;
var
  a: array of WideString;
begin
  FReserveList := TUwscList.Create(a, false);
  FReserve2List := TUwsc2List.Create(a, false);
  FReserve3List := TUwsc3List.Create(a, false);
end;

function TModeUwsc.NewParser(target: TNotePadString): TNotePadParser;
begin
  Result := TParserUwsc.Create(target, self);
end;


{ TParserUwsc }

constructor TParserUwsc.Create(target: TNotePadString; mode: TModeUwsc);
begin
  inherited Create(target, mode);
end;

procedure TParserUwsc.ParseToken(AHttp: boolean);
var
  C2: WideChar;
begin
  case FSb[FParsePos] of
    '/': begin
      if FParsePos < FSb.StringLength - 1 then begin
        C2 := FSb[FParsePos + 1];
        if C2 = '/' then begin
          inc(FParsePos);
          ParseToken(toComment);
          exit;
        end;
       end;
    end;
    '"': begin
      if FParsePos < FSb.StringLength - 1 then begin
        C2 := FSb[FParsePos + 1];
        if C2 <> #10 then begin
          inc(FParsePos);
          ParseToken(toDoubleQuotation);
          exit;
        end;
      end;
      ParseToken(toDoubleQuotation);
      exit;
    end;
    '$': begin
      ParseToken(toHex);
      exit;
    end;
  end;//case
  inherited ParseToken(false);
end;

procedure TParserUwsc.ParseToken(const C: WideChar);
begin
  case C of
    toDoubleQuotation: begin
      FToken := C;
      DoubleQuotationProc;
    end;
    toComment: begin
      FToken := C;
      CommentProc;
    end;
    toHex: begin
      FToken := C;
      HexProc;
    end;
    else inherited;
  end;
end;

initialization
  FHash1 := THash1.Create;
  FHash2 := THash2.Create;
  FHash3 := THash3.Create;
finalization
  FHash1.Free;
  FHash2.Free;
  FHash3.Free;
end.
