unit ModeVisualBasic;

interface

uses Windows, NotePadMode, NotePadString;

type
  TModeVisualBasic = class(TNotePadMode)
  protected
    procedure InitReserveList;override;
  public
    function NewParser(target: TNotePadString): TNotePadParser;override;
  end;

  TParserVisualBasic = class(TNotePadParser)
  private
  protected
    procedure ParseToken(AHttp: boolean);overload;override;
    procedure ParseToken(const C: WideChar);overload;override;
  public
    constructor Create(target: TNotePadString; mode: TModeVisualBasic);
  end;

implementation

uses NotePadClasses, ParserConsts;

const
  ss1: array[0..150] of WideString =(
'AddHandler',
'AddressOf',
'Alias',
'And',
'AndAlso',
'As',
'Boolean',
'ByRef',
'Byte',
'ByVal',
'Call',
'Case',
'Catch',
'CBool',
'CByte',
'CChar',
'CDate',
'CDec',
'CDbl',
'Char',
'CInt',
'Class',
'CLng',
'CObj',
'Const',
'Continue',
'CSByte',
'CShort',
'CSng',
'CStr',
'CType',
'CUInt',
'CULng',
'CUShort',
'Date',
'Decimal',
'Declare',
'Default',
'Delegate',
'Dim',
'DirectCast',
'Do',
'Double',
'Each',
'Else',
'ElseIf',
'End',
'EndIf',
'Enum',
'Erase',
'Error',
'Event',
'Exit',
'False',
'Finally',
'For',
'Friend',
'Function',
'Get',
'GetType',
'Global',
'GoSub',
'GoTo',
'Handles',
'If',
'Implements',
'Imports',
'In',
'Inherits',
'Integer',
'Interface',
'Is',
'IsNot',
'Let',
'Lib',
'Like',
'Long',
'Loop',
'Me',
'Mod',
'Module',
'MustInherit',
'MustOverride',
'MyBase',
'MyClass',
'Namespace',
'Narrowing',
'New',
'Next',
'Not',
'Nothing',
'NotInheritable',
'NotOverridable',
'Object',
'Of',
'On',
'Operator',
'Option',
'Optional',
'Or',
'OrElse',
'Overloads',
'Overridable',
'Overrides',
'ParamArray',
'Partial',
'Private',
'Property',
'Protected',
'Public',
'RaiseEvent',
'ReadOnly',
'ReDim',
'REM',
'RemoveHandler',
'Resume',
'Return',
'SByte',
'Select',
'Set',
'Shadows',
'Shared',
'Short',
'Single',
'Static',
'Step',
'Stop',
'String',
'Structure',
'Sub',
'SyncLock',
'Then',
'Throw',
'To',
'True',
'Try',
'TryCast',
'TypeOf',
'UInteger',
'ULong',
'UShort',
'Using',
'Variant',
'Wend',
'When',
'While',
'Widening',
'With',
'WithEvents',
'WriteOnly',
'Xor');

  ss2: array[0..142] of WideString =(
'AppActivate',
'Asc',
'AscW',
'Beep',
'CallByName',
'ChDir',
'ChDrive',
'Choose',
'Chr',
'ChrW',
'Command',
'CreateObject',
'CurDir',
'DateAdd',
'DateDiff',
'DatePart',
'DateSerial',
'DateValue',
'Day',
'DDB',
'DeleteSetting',
'DerivedMath',
'Dir',
'Environ',
'EOF',
'ErrorToString',
'FileAttr',
'FileClose',
'FileCopy',
'FileDateTime',
'FileGet',
'FileGetObject',
'FileLen',
'FileOpen',
'FilePut',
'FilePutObject',
'FileWidth',
'Filter',
'Fix',
'Format',
'FormatCurrency',
'FormatDateTime',
'FormatNumber',
'FormatPercent',
'FreeFile',
'FV',
'GetAllSettings',
'GetAttr',
'GetChar',
'GetException',
'GetObject',
'GetSetting',
'Hex',
'Hour',
'IIf',
'Input',
'InputBox',
'InputString',
'InStr',
'InStrRev',
'Int',
'IPmt',
'IRR',
'IsArray',
'IsDate',
'IsDBNull',
'IsError',
'IsNothing',
'IsNumeric',
'IsReference',
'Join',
'Kill',
'LBound',
'LCase',
'Left',
'Len',
'LineInput',
'Loc',
'Lock',
'LOF',
'LSet',
'LTrim',
'Mid',
'Minute',
'MIRR',
'MkDir',
'Month',
'MonthName',
'MsgBox',
'NPer',
'NPV',
'Oct',
'Partition',
'Pmt',
'PPmt',
'Print',
'PrintLine',
'PV',
'QBColor',
'Randomize',
'Rate',
'Rename',
'Replace',
'Reset',
'RGB',
'Right',
'RmDir',
'Rnd',
'RSet',
'RTrim',
'SaveSetting',
'Second',
'Seek',
'SetAttr',
'Shell',
'SLN',
'Space',
'SPC',
'Split',
'Str',
'StrComp',
'StrConv',
'StrDup',
'StrReverse',
'Switch',
'SYD',
'SystemTypeName',
'Tab',
'TimeSerial',
'TimeValue',
'Trim',
'TypeName',
'UBound',
'UCase',
'Unlock',
'Val',
'VarType',
'VbTypeName',
'Weekday',
'WeekdayName',
'Write',
'WriteLine',
'Year');

type
  THash1 = class(THashTable)
  protected
    procedure InitTable; override;
  public
    function isReserbed(const Value: WideString): boolean; override;
  end;

{ THash1 }

procedure THash1.InitTable;
var
  aa1: array of word;
  i, j: integer;
begin
  FSize := 307;{}
  FMaxLen := 1;
  SetLength(aa1, Length(ss1{}));
  for i := 0 to  Length(aa1) - 1 do begin
    aa1[i] := AnkToHash(ss1{}[i]);
    if Length(ss1{}[i]) > FMaxLen then FMaxLen := Length(ss1{}[i]);
  end;
  SetLength(FTable, FSize);
  for i := 0 to  Length(FTable) - 1 do begin
    FTable[i] := 0;
  end;
  for i := 0 to  Length(aa1) - 1 do begin
    j := aa1[i];
    while FTable[j] > 0 do begin
      inc(j);
      if j >= Length(FTable) then dec(j, Length(FTable) - 1);
    end;
    FTable[j] := i + 1;
  end;
end;

function THash1.isReserbed(const Value: WideString): boolean;
var
  i: integer;
begin
  Result := false;
  if Length(Value) > FMaxLen then exit;
  i := AnkToHash(Value);
  while FTable[i] > 0 do begin
    if CharLowerW(PWChar(ss1{}[FTable[i] - 1])) = Value then begin
      Result := true;
      exit;
    end;
    inc(i);
    if i >= FSize then dec(i, FSize);
  end;
end;

type
  THash2 = class(THashTable)
  protected
    procedure InitTable; override;
  public
    function isReserbed(const Value: WideString): boolean; override;
  end;

{ THash2 }

procedure THash2.InitTable;
var
  aa1: array of word;
  i, j: integer;
begin
  FSize := 307;{}
  FMaxLen := 1;
  SetLength(aa1, Length(ss2{}));
  for i := 0 to  Length(aa1) - 1 do begin
    aa1[i] := AnkToHash(ss2{}[i]);
    if Length(ss2{}[i]) > FMaxLen then FMaxLen := Length(ss2{}[i]);
  end;
  SetLength(FTable, FSize);
  for i := 0 to  Length(FTable) - 1 do begin
    FTable[i] := 0;
  end;
  for i := 0 to  Length(aa1) - 1 do begin
    j := aa1[i];
    while FTable[j] > 0 do begin
      inc(j);
      if j >= Length(FTable) then dec(j, Length(FTable) - 1);
    end;
    FTable[j] := i + 1;
  end;
end;

function THash2.isReserbed(const Value: WideString): boolean;
var
  i: integer;
begin
  Result := false;
  if Length(Value) > FMaxLen then exit;
  i := AnkToHash(Value);
  while FTable[i] > 0 do begin
    if CharLowerW(PWChar(ss2{}[FTable[i] - 1])) = Value then begin
      Result := true;
      exit;
    end;
    inc(i);
    if i >= FSize then dec(i, FSize);
  end;
end;

var
  FHash1: THash1;
  FHash2: THash2;

type
  TVisualBasicList = class(TReserveList)
  public
    function Find(const s: WideString): boolean; override;
  end;

{ TVisualBasicList }

function TVisualBasicList.Find(const s: WideString): boolean;
begin
  Result := FHash1.isReserbed(CharLowerW(PWChar(s)));
end;

type
  TVisualBasic2List = class(TReserveList)
  public
    function Find(const s: WideString): boolean; override;
  end;

{ TVisualBasic2List }

function TVisualBasic2List.Find(const s: WideString): boolean;
begin
  Result := FHash2.isReserbed(CharLowerW(PWChar(s)));
end;

{ TModeVisualBasic }

procedure TModeVisualBasic.InitReserveList;
var
  a: array of WideString;
begin
  FReserveList := TVisualBasicList.Create(a, false);
  FReserve2List := TVisualBasic2List.Create(a, true);
  FReserve3List := TReserveList.Create(a, true);
end;

function TModeVisualBasic.NewParser(target: TNotePadString): TNotePadParser;
begin
  Result := TParserVisualBasic.Create(target, self);
end;


{ TParserVisualBasic }

constructor TParserVisualBasic.Create(target: TNotePadString;
  mode: TModeVisualBasic);
begin
  inherited Create(target, mode);
end;

procedure TParserVisualBasic.ParseToken(AHttp: boolean);
var
  C2, C3, C4: WideChar;
begin
  case FSb[FParsePos] of
    '"': begin
      if FParsePos < FSb.StringLength - 1 then begin
        C2 := FSb[FParsePos + 1];
        if C2 <> #10 then begin
          inc(FParsePos);
          ParseToken(toDoubleQuotation);
          exit;
        end;
      end;
      ParseToken(toDoubleQuotation);
      exit;
    end;
    '''': begin
      ParseToken(toComment);
      exit;
    end;
    '#': begin
      ParseToken(toDirective);
      exit;
    end;
    '&': begin
      if FParsePos < FSb.StringLength - 1 then begin
        C2 := FSb[FParsePos + 1];
        if (C2 = 'H') or (C2 = 'h') then begin
          inc(FParsePos);
          ParseToken(toHex);
          exit;
        end;
      end;
    end;
    'R', 'r': begin
      if FParsePos < FSb.StringLength - 2 then begin
        C2 := FSb[FParsePos + 1];
        C3 := FSb[FParsePos + 2];
        if ((C2 = WideChar('E')) or (C2 = WideChar('e')))
           and ((C3 = WideChar('M')) or (C3 = WideChar('m'))) then begin
          if FParsePos < FSb.StringLength - 3 then begin
            C4 := FSb[FParsePos + 3];
            if (C4 >= WideChar('0')) and (C4 <= WideChar('z')) and
              ((C4 >= WideChar('a')) or (C4 = WideChar('_')) or
              ((C4 <= WideChar('Z'))and((C4 >= WideChar('A')) or (C4 <= WideChar('9'))))) then begin
              inherited;
              exit;
            end;
          end;
          inc(FParsePos, 2);
          ParseToken(toComment);
          exit;
        end;
      end;
    end;
  end;//case
  inherited ParseToken(false);
end;

procedure TParserVisualBasic.ParseToken(const C: WideChar);
begin
  case C of
    toDoubleQuotation: begin
      FToken := C;
      DoubleQuotationProc;
    end;
    toComment: begin
      FToken := C;
      CommentProc;
    end;
    toDirective: begin
      FToken := C;
      CommentProc;
    end;
    toHex: begin
      FToken := C;
      HexProc;
    end;
    else inherited;
  end;
end;

initialization
  FHash1 := THash1.Create;
  FHash2 := THash2.Create;
finalization
  FHash1.Free;
  FHash2.Free;
end.
