unit codeconv;
//JISX0201 e J^Ji
//JISX0208 ꐅA񐅏 񊿎
//JISX0212 ⏕

//EUCϊɂ
//http://www.asahi-net.or.jp/~hc3j-tkg/unicode/
//JISX0201 + JISX0208 ł ShiftJIS  Unicode ɕϊ̂ɂ͓ɖ͂܂B
//ASCII + JISX0201 Kana + JISX0208 + JISX0212 ł{ EUC
//http://www2d.biglobe.ne.jp/~msyk/charcode/jisx0201kana/index.html
//0xxxxxxx e[}
//1xxxxxxx 1xxxxxxx JIS X 0208 
//SS2 1xxxxxxx JIS X 0201 Љ
//SS3 1xxxxxxx 1xxxxxxx JIS X 0212 ⏕
//肪̂́A
//$8F $80-$FF $80-FF
//Ƃ3oCgŕ\Ă⏕łB
//CP20932MS-EUCSĒׂ킯ł͂ȂÄ̗́A
//$80-$FF $00-7F
//Ƃ2oCgɃ}bvA
//1oCgڂ͖{ƂƓA2oCgڂ͖{-$80Ƀ}bvĂ悤B
//āA{EUC<->MS-EUC<->UTF-16̕ϊ͊ȒPI
//_F
//ꕔ̃}bvEUCƈقȂĂB
//SJISO̕ɑΉ邱ƂŁASJIS̕]ɂȂ̂̓}YCB
//WideCharToMultiByteŁASJISɂ͕ϊôEUCɂ͕ϊoȂ̂14
//0080,2225,301D,663B,F8F0,F8F1,F8F2,F8F3,FF0D,FF5E,FFE0,FFE1,FFE2,FFE4,

//ISO-2022-JPϊɂ
//JISƂR[h̋Ki͂񂠂邪A
//http://e-words.jp/w/ISO-2022-JP.html
//܂A{ɂdq[M̂߂JISgƂƂȂ̂ŁA
//dq[ŗp̂ƓJISɑΉΗǂA
//ȊOJIS͋Ki݂ƌ́ANgȂJISƂƂɂȂB
//JIS̃oG[V
//http://ja.wikipedia.org/wiki/ISO-2022-JP
//ISO-2022-JP('78)   JISX208̕'78N ́uJISv
//ISO-2022-JP('83)   JISX208̕'83N ́uVJISv
//ISO-2022-JP('97)   JISX208̕'97N '90upv'97uKǐv
//ISO-2022-JP('00)   JISX208̕'00N
//ISO-2022-JP-1      JISX0212(⏕)̒ǉ
//ISO-2022-JP-2      JISX0212ƃnOA̒ǉ
//ISO-2022-JP-3      lbgŗpłȂI
//ISO-2022-JP-2004   lbgŗpłȂI
//WindowsŗpłR[hy[W
//iso-2022-jp 50220 Japanese (JIS)                   JiȂ
//csISO2022JP 50221 Japanese (JIS-Allow 1 byte Kana) Ji
//iso-2022-jp 50222 Japanese (JIS-Allow 1 byte Kana) JiSO/SI
//3̈Ⴂ͔pJ^Ji̕\@̂݁B
//http://kanji.zinbun.kyoto-u.ac.jp/~yasuoka/kanjibukuro/japan.html

//jconvertłESC$BƑJIS83AESC$@ƑJIS78ƒf肵ĂB
//jconvertłESC$ŃIAESC(ŃItA1Ď2ToJisȂ̂ŁA
//ǂݍݕϊ8378̋ʂ͂ĂȂB
(*
  JISϊ̎dl
  ASCIIJISX0201̋ʂ͂A0201ϊe[ugB
  JISX0208́Ajconvert.pasōe[upB
  p̈AO7bit\oȂ̂œǂݍނǏ܂ȂB

  ǂݍ݂̎dl
            : JISC0201[h
  ESC$@             : JISX0208[hɐ؂ւ({JIS78)
  ESC$B             : JISX0208[hɐ؂ւ({JIS83)
  ESC(B             : JISX0201[hɐ؂ւ({ASCII)
  ESC(J             : JISX0201[hɐ؂ւ({JISX0201)
  JISX0201SO    : SO&SIpJ^Ji[hɐ؂ւ
  SOSI          : JISX0201[hɐ؂ւ
  ESC(I             : pJ^Ji[hɐ؂ւ
  ESC$(D            : JISX0212[hɐؑ

  ݂̎dl
  OɔpJiSpJiɕϊB
  ESC$BESC(BgȂB
  
*)

//nƌ̃IvVƁA50220 50221 50222͊DF\Ȃ̂ɁA
//20932͊DFȂă`FbN{bNXOƂoB
//܂AJISϊoȂ͂ȂAEUCϊoȂ͂肤B


interface

uses Windows;


//R[h
const
  ENC_ASCII = 0;
  ENC_SJIS  = 1;
  ENC_EUC   = 2;
  ENC_JIS   = 3;
  ENC_UTF7  = 4;
  ENC_UTF8  = 5;
  ENC_ANY   = 6;
//BOMŔł̂BOMgĂƂŁAȊO̕p
function EncodingCheck(const Value: AnsiString; len: integer): integer;

//CP20932gOS݂EUCϊi܂j
function Euc2Wide20932(const Value: AnsiString): WideString;
function Wide2Euc20932(const Value: WideString; CRLF2LF, CR2LF: boolean): AnsiString;
//e[ugEUCϊi{j
function Euc2Wide(const Value: AnsiString): WideString;
function Wide2Euc(const Value: WideString; CRLF2LF, CR2LF: boolean): AnsiString;
//e[ugJIS̕ϊ
function Jis2Wide(const Value: AnsiString): WideString;
//pJiSpɕϊAԖJISւ̕ϊ
function Wide2Jis(const Value: WideString): AnsiString;


implementation

uses codeconvsub;

const
  SS2: AnsiChar = #$8E;
  SS3: AnsiChar = #$8F;


function EncodingCheck(const Value: AnsiString; len: integer): integer;
//ۂ̏̊֐͂ǂ̂
//len̒Value̒AS[ƂB
//Result̏lASCIIɂB
//At@xbgȂǂASCIIgĂȂꍇ́A
//ǂ̕R[hœǂݍłȂ񂾂ASCIIƂȂB
//rUTF7ƒfo镔ΑIB1炢͋R邩Ȃ̂ŁB
//rJISƒfł镔1JΑIB
//rASCIIȊO̕JISUTF7̔߂B
//JISUTF7̔͊ɏoBiԂj
//cO͓̔isAfł_őIB
//ǂƂfłȂꍇAȃ}`oCg̃oCgŔrB
//{IɁAAЂ炪Ȃ܂ރt@Cł͕ȂB
//ȊOł͊ԈႤƂ܂ɂB
//UTF-8̃t@C͗DxグĂ̂ŁASJISEUCɊԈႦ邱Ƃ͂ȂBiԂj
//2Ô݂ō\SJIŚAUTF-8ƊԈႦ邩mȂB
//pJi܂݁ASpJiЂ炪Ȃ܂܂ȂSJISEUCƊԈႦ邩mȂB
//EUCSJISUTF-8ɊԈႦ邱Ƃ́uقځvȂBЂ炪ȂJ^JigΊB
//قƂǂ̓{t@C͂Ђ炪Ȃ܂ނ̂ŕ̐Sz͂ȂB
//̑̏ꍇłȃ}`oCg̃oCgrŐx\Ȃ͂B

var
  i: integer;
  AUTF7, AUTF8, ASJIS, AEUC: integer;
  AANY: integer;
  CUTF7, CUTF8, CSJIS, CEUC: integer;
  sum: integer;
begin
  Result := ENC_ASCII;
  if Length(Value) < len then len := Length(Value);
  AUTF7 := 1;
  AUTF8 := 1;
  ASJIS := 1;
  AEUC  := 1;
  AANY  := 3;
  CUTF7 := 0;
  CUTF8 := 0;
  CSJIS := 0;
  CEUC  := 0;
  for i := 1 to len do begin
    //7bitpR[h
    if Result = ENC_ASCII then begin
      if Byte(Value[i]) > $7F then begin
        Result := ENC_ANY;
      end else if Value[i] = #$1B then begin
        //JIS̔
        //8bitg邱Ƃ邪AESC̕ɗ͂Ȃ̂łŁB
        //Y3ꍇ͔I
        if i + 2 <= len then begin
          if ((Value[i + 1] = '$') and (Value[i + 2] in['@', 'B', '('])) or
             ((Value[i + 1] = '(') and (Value[i + 2] in['B', 'J', 'I'])) then begin
            Result := ENC_JIS;
            exit;
          end;
        end;
      end else if (AUTF7 > 0) and (AUTF7 <= i) then begin
        //UTF7̔
        if Value[AUTF7] = '+' then begin//UTF7ubNJn̍}
          inc(AUTF7);
          sum := 0;
          while AUTF7 <= len do begin
            case Value[AUTF7] of
              '0'..'9', 'A'..'Z', 'a'..'z', '+', '/': inc(sum);
              '-': begin
                if ((sum * 6) mod 16) > 5 then begin
                  AUTF7 := 0;
                  break;
                end;
                //UTF7ubNR2ڂƂ
                if CUTF7 > 0 then begin
                  Result := ENC_UTF7;
                  exit;
                end;
                inc(AUTF7);
                //UTF7ubNR1ڂƂ
                inc(CUTF7, AUTF7 - i);//
                break;
              end;
              else begin
                AUTF7 := 0;
                break;
              end;
            end;
            inc(AUTF7);
          end;//while
          //Ă邩ǂ͊mFȂĂACUTF7ł킩
        end else begin
          case Value[AUTF7] of
            #$9, #$10, #$13, #$20,
            'A'..'Z', 'a'..'z', ''''..')', ','..':', '?': inc(AUTF7);
            else begin
              //ȊOASCII
              AUTF7 := 0;
            end;
          end;
        end;
      end;
    end;
    //7bit낤8bit낤AUTF8ASJISAEUC͍̔s
    if (AUTF8 > 0) and (AUTF8 <= i) then begin
      //UTF8
      //100000-10FFFFF܂ł̗̈ɑΉ
      case Value[AUTF8] of
        #$00..#$7F: inc(AUTF8);
        #$C2..#$DF: begin
          if (AUTF8 + 1 <= len) and (Value[AUTF8 + 1] in [#$80..#$BF]) then begin
            inc(AUTF8, 2);
            inc(CUTF8, 2);
          end else begin
            AUTF8 := 0;
            dec(AANY);
          end;
        end;
        #$E0: begin
          if (AUTF8 + 2 <= len) and (Value[AUTF8 + 1] in [#$A0..#$BF])
                                and (Value[AUTF8 + 2] in [#$80..#$BF]) then begin
            inc(AUTF8, 3);
            inc(CUTF8, 3);
          end else begin
            AUTF8 := 0;
            dec(AANY);
          end;
        end;
        #$E1..#$EF: begin
          if (AUTF8 + 2 <= len) and (Value[AUTF8 + 1] in [#$80..#$BF])
                                and (Value[AUTF8 + 2] in [#$80..#$BF]) then begin
            inc(AUTF8, 3);
            inc(CUTF8, 3);
          end else begin
            AUTF8 := 0;
            dec(AANY);
          end;
        end;
        #$F0: begin
          if (AUTF8 + 3 <= len) and (Value[AUTF8 + 1] in [#$90..#$BF])
                                and (Value[AUTF8 + 2] in [#$80..#$BF])
                                and (Value[AUTF8 + 3] in [#$80..#$BF]) then begin
            inc(AUTF8, 4);
            inc(CUTF8, 4);
          end else begin
            AUTF8 := 0;
            dec(AANY);
          end;
        end;
        #$F1..#$F3: begin
          if (AUTF8 + 3 <= len) and (Value[AUTF8 + 1] in [#$80..#$BF])
                                and (Value[AUTF8 + 2] in [#$80..#$BF])
                                and (Value[AUTF8 + 3] in [#$80..#$BF]) then begin
            inc(AUTF8, 4);
            inc(CUTF8, 4);
          end else begin
            AUTF8 := 0;
            dec(AANY);
          end;
        end;
        #$F4: begin
          if (AUTF8 + 3 <= len) and (Value[AUTF8 + 1] in [#$80..#$8F])
                                and (Value[AUTF8 + 2] in [#$80..#$BF])
                                and (Value[AUTF8 + 3] in [#$80..#$BF]) then begin
            inc(AUTF8, 4);
            inc(CUTF8, 4);
          end else begin
            AUTF8 := 0;
            dec(AANY);
          end;
        end;
        else begin
          AUTF8 := 0;
          dec(AANY);
        end;
      end;
    end;
    if (ASJIS > 0) and (ASJIS <= i) then begin
      //SJIS
      case Value[ASJIS] of
        #$00..#$7F:inc(ASJIS);
        #$A0..#$DF:inc(ASJIS);//pJ^Ji
        #$80:inc(ASJIS);//悭킩Ȃ11ŕϊłB
        //EUCSJISɕϊƔJi炯ɂȂ킯A
        //̔p̈ŉ_ȂEUCLŕϊłB
        #$81..#$9F,
        #$E0..#$FC:begin
          if (ASJIS + 1 <= len) and (Value[ASJIS + 1] in [#$40..#$7E, #$80..#$FC]) then begin
            inc(ASJIS, 2);
            inc(CSJIS, 2);
          end else begin
            ASJIS := 0;
            dec(AANY);
          end;
        end;
        else begin
          ASJIS := 0;
          dec(AANY);
        end;
      end;
    end;
    if (AEUC > 0) and (AEUC <= i) then begin
      //EUC
      case Value[AEUC] of
        #$00..#$7F: inc(AEUC);
        //Ji
        #$8E:begin
          if (AEUC + 1 <= len) and (Value[AEUC + 1] in [#$A1..#$DF]) then begin
            inc(AEUC, 2);
            inc(CEUC, 2);
          end else begin
            AEUC := 0;
            dec(AANY);
          end;
        end;
        //⏕
        #$8F:begin
          if (AEUC + 2 <= len) and (Value[AEUC + 1] in [#$A1..#$FE])
                               and (Value[AEUC + 2] in [#$A1..#$FE]) then begin
            inc(AEUC, 3);
            inc(CEUC, 3);
          end else begin
            AEUC := 0;
            dec(AANY);
          end;
        end;
      //SJISoRϊƎp̈ɐHނ̂$FF
        #$A1..#$FF: begin
          if (AEUC + 1 <= len) and (Value[AEUC + 1] in [#$A1..#$FE]) then begin
            inc(AEUC, 2);
            inc(CEUC, 2);
          end else begin
            AEUC := 0;
            dec(AANY);
          end;
        end;
        else begin
          AEUC := 0;
          dec(AANY);
        end;
      end;
    end;
    //7bitgĂȂꍇ͔UTF8SJISEUCʂłȂ̂ŁA
    //܂7bitgĂȂꍇ͔葱s
    if Result = ENC_ASCII then Continue;
    //8bitgA₪iꂽꍇB
    if AANY <= 1 then begin
      if AUTF8 > 0 then begin
        Result := ENC_UTF8;
        exit;
      end else if ASJIS > 0 then begin
        Result := ENC_SJIS;
        exit;
      end else if AEUC > 0 then begin
        Result := ENC_EUC;
        exit;
      end else begin
        //܂ŕ̕R[hŒʂĂ̂ɂȂSłꍇA
        //s͂̉\̂Ŕ͕s\ŏI
        //Lȃ}`oCgubNȂꍇANYԂ
        if CUTF7 > 0 then Result := ENC_UTF7;
        if CUTF8 > CUTF7 then Result := ENC_UTF8;
        if (CSJIS > CUTF7) and (CSJIS > CUTF8) then Result := ENC_SJIS;
        if (CEUC > CUTF7) and (CEUC > CUTF8) and (CEUC > CSJIS) then Result := ENC_EUC;
        exit;
      end;
    end;
  end;//for
  //Ō̕܂Ŕ肵Ă܂ꍇ
  //UTF-7ubNۗL7bitR[hUTF7
  //ȊO̓[vł̗Dx̂܂
  if (Result = ENC_ASCII) and (AUTF7 > 0) and (CUTF7 > 0) then Result := ENC_UTF7 else begin
    if (AUTF8 > 0) and (CUTF8 > 0) then Result := ENC_UTF8;
    if (ASJIS > 0) and (CSJIS > CUTF8) then Result := ENC_SJIS;
    if (AEUC > 0) and (CEUC > CUTF8) and (CEUC > CSJIS) then Result := ENC_EUC;
  end;
end;

function Euc2Wide20932(const Value: AnsiString): WideString;
var
  i, j: integer;
  len : integer;
  s: AnsiString;
begin
  len := Length(Value);
  SetLength(s, len);
  i := 1;//͕Kinc
  j := 1;//inĉ͕ꂽƂ̂
  while i <= len do begin
    case Value[i] of
      //e
      #$00..#$7F:begin
        s[j] := Value[i];
        inc(j);
        inc(i);
      end;
      //⏕
      #$8F: begin
        if (i + 2 <= len) and (Value[i + 1] >= #$80) and (Value[i+ 1] <=#$FF) and
            (Value[i + 2] >= #$80) and (Value[i+ 2] <=#$FF) then begin
          inc(i);
          s[j] := Value[i];
          inc(j);
          inc(i);
          s[j] := AnsiChar(byte(Value[i]) - $80);
          inc(j);
          inc(i);
        end else begin
        //MultiByteToWideCharɏ]AsoCg𖳌
          inc(i);
        end;
      end;
      //Ji낤낤eC͈͓͂
      else begin
        if (i + 1 <= len) and (Value[i + 1] >= #$80) and (Value[i+ 1] <=#$FF) then begin
          s[j] := Value[i];
          inc(j);
          inc(i);
          s[j] := Value[i];
          inc(j);
          inc(i);
        end else begin
        //MultiByteToWideCharɏ]AsoCg𖳌
          inc(i);
        end;
      end;
    end;//case
  end;//while
  i := MultiByteToWideChar(20932, 0, PAnsiChar(s), j - 1, nil, 0);
  SetLength(Result, i);
  SetLength(Result, MultiByteToWideChar(20932, 0, PAnsiChar(s), j - 1, PWChar(Result), i));
end;

function Wide2Euc20932(const Value: WideString; CRLF2LF, CR2LF: boolean): AnsiString;
var
  i, j: integer;
  b: bool;
  s: AnsiString;
  len: integer;
begin
  len := WideCharToMultiByte(20932, 0, PWChar(Value), Length(Value), nil, 0, nil, @b);
  SetLength(s, len);
  len := WideCharToMultiByte(20932, 0, PWChar(Value), Length(Value), PAnsiChar(s), len, nil, @b);
  SetLength(s, len);
  SetLength(Result, len * 2);
  i := 1;//͕Kinc
  j := 1;//inĉ͕ꂽƂ̂
  while i <= len do begin
    case s[i] of
      #$80..#$FF:begin
        if (i + 1 <= len) then begin
          if s[i + 1] < #$80 then begin
            Result[j] := #$8F;
            inc(j);
            Result[j] := s[i];
            inc(j);
            inc(i);
            Result[j] := AnsiChar(byte(s[i]) + $80);
            inc(j);
            inc(i);
          end else begin
            Result[j] := s[i];
            inc(j);
            inc(i);
            Result[j] := s[i];
            inc(j);
            inc(i);
          end;
        end else begin
          inc(i);
        end;
      end;
      #13:begin
        if (CRLF2LF) and (i + 1 <= len) and (s[i + 1] = #10) then begin
          Result[j] := #10;
          inc(j);
          inc(i, 2);
        end else if (CR2LF) and ((i + 1 > len) or (s[i + 1] <> #10)) then begin
          Result[j] := #10;
          inc(j);
          inc(i);
        end else begin
          Result[j] := s[i];
          inc(j);
          inc(i);
        end;
      end;
      else begin
        Result[j] := s[i];
        inc(j);
        inc(i);
      end;
    end;//case
  end;//while
  SetLength(Result, j - 1);
end;

function Euc2Wide(const Value: AnsiString): WideString;
var
  i, j: integer;
  WC: WideChar;
  len : integer;
begin
  len := Length(Value);
  SetLength(Result, len);
  i := 1;//͕Kinc
  j := 1;//inĉ͕ꂽƂ̂
  while i <= len do begin
    case Value[i] of
      //Ji
      #$8E:begin
        if (i + 1 <= len) and (Value[i + 1] >= #$A1) and (Value[i+ 1] <=#$DF) then begin
          WC := JISX0201ToUTF16[word(Value[i + 1])];
          if WC <> #0 then begin
            Result[j] := WC;
            inc(j);
            inc(i, 2);
          end else begin
            //MultiByteToWideCharɏ]AsoCg𖳌
            inc(i);
          end;
        end else begin
        //MultiByteToWideCharɏ]AsoCg𖳌
          inc(i);
        end;
      end;
      //⏕
      #$8F:begin
        if (i + 2 <= len) and (Value[i + 1] >= #$A1) and (Value[i+ 1] <=#$FE) and
            (Value[i + 2] >= #$A1) and (Value[i+ 2] <=#$FE) then begin
          WC := JISX0212ToUTF16[word(Value[i + 1]) - $80][word(Value[i + 2]) - $80];
          if WC <> #0 then begin
            Result[j] := WC;
            inc(j);
            inc(i, 3);
          end else begin
            //MultiByteToWideCharɏ]AsoCg𖳌
            inc(i);
          end;
        end else begin
        //MultiByteToWideCharɏ]AsoCg𖳌
          inc(i);
        end;
      end;
      //ꐅA񐅏
      else begin
        if (i + 1 <= len) and (Value[i] >= #$A1) and (Value[i] <=#$FE) and
            (Value[i + 1] >= #$A1) and (Value[i+ 1] <=#$FE) then begin
          WC := JISX0208ToUTF16[word(Value[i]) - $80][word(Value[i + 1]) - $80];
          if WC <> #0 then begin
            Result[j] := WC;
            inc(j);
            inc(i, 2);
          end else begin
            //MultiByteToWideCharɏ]AsoCg𖳌
            inc(i);
          end;
        end else begin
          //e
          //₵1oCĝ₵Ƃĕϊ炵
          //$80Ƃ܂܂ꂽꍇȂǁB
          Result[j] := WideChar(word(byte(Value[i])));
          inc(j);
          inc(i);
        end;
      end;
    end;//case
  end;//while
  SetLength(Result, j - 1);
end;

function Wide2Euc(const Value: WideString; CRLF2LF, CR2LF: boolean): AnsiString;
var
  i, j: integer;
  len: integer;
  w: integer;
begin
  len := Length(Value);
  SetLength(Result, len * 3);//ő3oCg̕邩
  i := 1;//͕Kinc
  j := 1;//inĉ͕ꂽƂ̂
  while i <= len do begin
    case Value[i] of
      #0: begin
        Result[j] := #0;
        inc(j);
        inc(i);
      end;
      #13: begin
        if (CRLF2LF) and (i + 1 <= len) and (Value[i + 1] = #10) then begin
          Result[j] := #10;
          inc(j);
          inc(i, 2);
        end else if (CR2LF) and ((i + 1 > len) or (Value[i + 1] <> #10)) then begin
          Result[j] := #10;
          inc(j);
          inc(i);
        end else begin
          Result[j] := #13;
          inc(j);
          inc(i);
        end;
      end;
      #$E000..#$E757:begin
        Result[j] := '?';
        inc(j);
        inc(i);
      end;
      else begin
        w := UTF16ToJIS[Word(Value[i])];
        case w of
          0:begin
            Result[j] := '?';
            inc(j);
            inc(i);
          end;
          $A1..$DF:begin
            Result[j] := #$8E;
            Result[j + 1] := AnsiChar(byte(w));
            inc(j, 2);
            inc(i);
          end;
          $2121..$7E7E:begin
            Result[j] := AnsiChar(byte(((w and $FF00) shr 8) + $80));
            Result[j + 1] := AnsiChar(byte((w and $FF) + $80));
            inc(j, 2);
            inc(i);
          end;
          $A121..$FE7E:begin
            Result[j] := #$8F;
            Result[j + 1] := AnsiChar(byte(((w and $FF00) shr 8)));
            Result[j + 2] := AnsiChar(byte((w and $FF) + $80));
            inc(j, 3);
            inc(i);
          end;
          else begin
            Result[j] := AnsiChar(byte(w));
            inc(j);
            inc(i);
          end;
        end;//case
      end;
    end;//case
  end;//while
  SetLength(Result, j - 1);
end;

function Jis2Wide(const Value: AnsiString): WideString;
const
  M_0201 = 0;
  M_0208 = 1;
  M_SOSI = 2;
  M_Kana = 3;
  M_0212 = 4;
var
  i, j: integer;
  len: integer;
  m: integer;
  w: WideChar;
begin
  //ۂ̂ƂA0208Ȃ̂0208ɐ؂ւƂǂ邩H
  //Vɏ]ĂȂeLXgłJǂ̂ŁA
  //؂ւXCb`ƂɃ`FbNȂǂB
  len := Length(Value);
  SetLength(Result, len);
  i := 1;//͕Kinc
  j := 1;//inĉ͕ꂽƂ̂
  m := M_0201;
  while i <= len do begin
    case Value[i] of
      #$1B:begin//ESC
        if (i + 2 <= len) and (Value[i + 1] = '$') and ((Value[i + 2] = 'B') or (Value[i + 2] = '@')) then begin
          m := M_0208;
          inc(i, 3);
        end else if (i + 2 <= len) and (Value[i + 1] = '(') and ((Value[i + 2] = 'B') or (Value[i + 2] = 'J')) then begin
          m := M_0201;
          inc(i, 3);
        end else if (i + 2 <= len) and (Value[i + 1] = '(') and (Value[i + 2] = 'I') then begin
          m := M_Kana;
          inc(i, 3);
        end else if (i + 3 <= len) and (Value[i + 1] = '$') and (Value[i + 2] = '(') and (Value[i + 3] = 'D') then begin
          m := M_0212;
          inc(i, 4);
        end else begin
          //ESCƂĕϊ
          Result[j] := #$1B;
          inc(j);
          inc(i);
        end;
      end;
      #$0E:begin//SO
        if m = M_0201 then begin
          m := M_SOSI;
          inc(i);
        end else begin
          //SO͕sSinOutƂēĂ
          Result[j] := #$0E;
          inc(j);
          inc(i);
        end;
      end;
      #$0F:begin//SI
        if m = M_SOSI then begin
          m := M_0201;
          inc(i);
        end else begin
          //SI͕sSinInƂēĂ
          Result[j] := #$0F;
          inc(j);
          inc(i);
        end;
      end;
      else begin
        case m of
          M_0201: begin
            w := JISX0201ToUTF16[Byte(Value[i])];
            if w = #0 then
              Result[j] := WideChar(Word(Byte(Value[i])))
            else
              Result[j] := w;
            inc(j);
            inc(i);
          end;
          M_0208:begin
            if (i + 1 <= len) and (Value[i] in [#$21..#$98]) and (Value[i + 1] in [#$21..#$7E]) then begin
              w := JISX0208ToUTF16[Byte(Value[i])][Byte(Value[i + 1])];
              if w <> #0 then begin
                Result[j] := w;
                inc(j);
                inc(i, 2);
              end else inc(i);//soCg
            end else begin
              //₵1Ƃď
              Result[j] := WideChar(word(byte(Value[i])));
              inc(j);
              inc(i);
            end;
          end;
          M_SOSI,M_Kana:begin
            if Value[i] in [#$21..#$5F] then begin
              Result[j] := JISX0201ToUTF16[Byte(Value[i]) + $80];
              inc(j);
              inc(i);
            end else begin
              //₵1Ƃď
              Result[j] := WideChar(Word(Byte(Value[i])));
              inc(j);
              inc(i);
            end;
          end;
          M_0212:begin
            if (i + 1 <= len) and (Value[i] in [#$21..#$7E]) and (Value[i + 1] in [#$21..#$7E]) then begin
              w := JISX0212ToUTF16[Byte(Value[i])][Byte(Value[i + 1])];
              if w <> #0 then begin
                Result[j] := w;
                inc(j);
                inc(i, 2);
              end else inc(i);//soCg
            end else begin
              //₵1Ƃď
              Result[j] := WideChar(word(byte(Value[i])));
              inc(j);
              inc(i);
            end;
          end;
          else begin
            Result[j] := WideChar(Word(Byte(Value[i])));
            inc(j);
            inc(i);
          end;
        end;//case
      end;
    end;
  end;//while
  SetLength(Result, j - 1);
end;

const
  wcZenKana: array[#$FF60..#$FF9F] of WideChar =  (
#$0000{O},#$3002{B},#$300C{u},#$300D{v},#$3001{A},#$30FB{E},#$30F2{},#$30A1{@},
#$30A3{B},#$30A5{D},#$30A7{F},#$30A9{H},#$30E3{},#$30E5{},#$30E7{},#$30C3{b},
#$30FC{[},#$30A2{A},#$30A4{C},#$30A6{E},#$30A8{G},#$30AA{I},#$30AB{J},#$30AD{L},
#$30AF{N},#$30B1{P},#$30B3{R},#$30B5{T},#$30B7{V},#$30B9{X},#$30BB{Z},#$30BD{\},
#$30BF{^},#$30C1{`},#$30C4{c},#$30C6{e},#$30C8{g},#$30CA{i},#$30CB{j},#$30CC{k},
#$30CD{l},#$30CE{m},#$30CF{n},#$30D2{q},#$30D5{t},#$30D8{w},#$30DB{z},#$30DE{}},
#$30DF{~},#$30E0{},#$30E1{},#$30E2{},#$30E4{},#$30E6{},#$30E8{},#$30E9{},
#$30EA{},#$30EB{},#$30EC{},#$30ED{},#$30EF{},#$30F3{},#$309B{J},#$309C{K});


function Wide2Jis(const Value: WideString): AnsiString;
var
  i, j, len, len2: integer;
  ws: WideString;
  s: AnsiString;
  b1: BOOL;
  js: AnsiString;
  c1, c2: byte;
  w: word;
begin
  //܂͔pJiׂ
  len := Length(Value);
  SetLength(ws, len);
  i := 1;//͕Kinc
  j := 1;//inĉ͕ꂽƂ̂
  while i <= len do begin
    if (Value[i] < #$FF61) or (Value[i] > #$FF9F) then begin
      case Value[i] of
        #$0080,
        #$F8F0, //$A0
        #$F8F1, //$FD
        #$F8F2, //$FE
        #$F8F3: //$FF
        ws[j] := #$3F; //JISɂĂ͂Ȃ4̕$80
        else begin
          ws[j] := Value[i];
        end;
      end;//case
      inc(j);
      inc(i);
    end else case Value[i] of
      #$FF61..#$FF72,
      #$FF74..#$FF75,
      #$FF85..#$FF89,
      #$FF8F..#$FF9F: begin
        ws[j] := wcZenKana[Value[i]];
        inc(j);
        inc(i);
      end;
      #$FF73: begin   //uEvɑ_
        if (i + 1 <= len) and (Value[i + 1] = #$FF9E) then begin
          ws[j] := #$30F4;
          inc(j);
          inc(i, 2);
        end else begin
          ws[j] := wcZenKana[Value[i]];
          inc(j);
          inc(i);
        end;
      end;
      #$FF76..#$FF84: begin  //Js^sɑ_
        if (i + 1 <= len) and (Value[i + 1] = #$FF9E) then begin
          ws[j] := WideChar(integer(wcZenKana[Value[i]]) + 1);
          inc(j);
          inc(i, 2);
        end else begin
          ws[j] := wcZenKana[Value[i]];
          inc(j);
          inc(i);
        end;
      end;
      #$FF8A..#$FF8E: begin //nsɑ_܂͔_
        if (i + 1 <= len) and (Value[i + 1] = #$FF9E) then begin
          ws[j] := WideChar(integer(wcZenKana[Value[i]]) + 1);
          inc(j);
          inc(i, 2);
        end else if (i + 1 <= len) and (Value[i + 1] = #$FF9F) then begin
          ws[j] := WideChar(integer(wcZenKana[Value[i]]) + 2);
          inc(j);
          inc(i, 2);
        end else begin
          ws[j] := wcZenKana[Value[i]];
          inc(j);
          inc(i);
        end;
      end;
      else begin
        ws[j] := Value[i];
        inc(j);
        inc(i);
      end;
    end;//case
  end;//while
  len := j - 1;
  //i := WideCharToMultiByte(50220, 0, PWChar(ws), len, nil, 0, nil, nil);
  //SetLength(Result, i);
  //i := WideCharToMultiByte(50220, 0, PWChar(ws), len, PAnsiChar(Result), i, nil, nil);
  //Result := Copy(Result, 1, i);
  SetLength(s, len * 2);//ő2oCgϊ
  i := WideCharToMultiByte(932, 0, PWChar(ws), len, PAnsiChar(s), len * 2, nil, @b1);
  len := i;
  SetLength(ws, len);
  len2 := len * 2;
  SetLength(Result, len2);//Ƃ肠2{ĂAƂɂȂ邩Ȃ
  i := 1;//͕Kinc
  j := 1;//inĉ͕ꂽƂ̂
  b1 := false;//ESC$B[hɓ܂tO
  SetLength(js, 2);//jis
  while i <= len do begin
    if j + 4 > len2 then begin //x5ނ̂ł̏ꏊ+4
      //߂ꏊȂȂ2{
      inc(len2, len2);
      SetLength(Result, len2);
    end;
    case s[i] of
      #$81..#$FF: begin
        //ɔJi͗ȂB
        //̑̕sȕ$A0,$FD,$FE,$FFϊς
        //āA2oCgڂ͊mɑ݂B
        if not b1 then begin
          Result[j] := #$1B;
          Result[j + 1] := #$24;
          Result[j + 2] := #$42;
          inc(j, 3);
          b1 := true;
        end;
        c1 := Byte(s[i]);
        c2 := Byte(s[i + 1]);
        if (c1 >= $FA) and (c1 <= $FC) then begin
          w := GaijiConv[c1][c2];
          if w <> 0 then begin
            c1 := byte((w and $FF00) shr 8);
            c2 := byte(w and $00FF);
          end;
        end;
          //jconvert.pas̃pNϊ
          //ʃoCg$9F܂ł́A2{256$20B
          //$A0`$DF̓J^JiB
          //$E0ȍ~́A2{384$20B
          //ꂾByte^ŌӂꂿႤ̂ŐɈĂ犄B
          //ʃoCǵA$9FȏȂ158$20B
          //$9Eȉ̏ꍇ͏ʃoCg1B
          //$80ȏȂ$40$20A$7F܂łȂ$3F$20B
          if c1 < $A0 then dec(c1, 112) else dec(c1, 176);
          c1 := c1 shl 1;
          if c2 > $9E then dec(c2, 126) else begin
            dec(c1);
            if c2 > $7F then dec(c2, 32) else dec(c2, 31);
          end;
        Result[j] := AnsiChar(c1);
        Result[j + 1] := AnsiChar(c2);
        inc(j, 2);
        inc(i, 2);
      end;
      else begin
        //ESCSO/SI܂܂ĂĂ̂܂ESCo
        if b1 then begin
          Result[j] := #$1B;
          Result[j + 1] := #$28;
          Result[j + 2] := #$42;
          Result[j + 3] := s[i];
          inc(j, 4);
          inc(i);
          b1 := false;
        end else begin
          Result[j] := s[i];
          inc(j);
          inc(i);
        end;
      end;
    end;//case
    if (i > len) and b1 then begin
      //IESC(Bɖ߂
      if j + 2 > len2 then SetLength(Result, j + 2);
      Result[j] := #$1B;
      Result[j + 1] := #$28;
      Result[j + 2] := #$42;
      inc(j, 3);
    end;
  end;//while
  SetLength(Result, j - 1); 
end;

end.
