unit ColorButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, stdctrls,Graphics;

type
  TColorButton = class(TButton)
  private
    fColor:TColor;
    procedure SetColor(c:TColor);
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    { Private 錾 }
  protected
    { Protected 錾 }
  public
    { Public 錾 }
  published
    property Color:TColor read fColor write SetColor;
    { Published 錾 }
  end;

procedure Register;

implementation

uses Types;

procedure Register;
begin
  RegisterComponents('Samples', [TColorButton]);
end;

{ TColorButton }

procedure TColorButton.SetColor(c: TColor);
begin
  fColor := c;
  Invalidate;
end;

procedure TColorButton.WMPaint(var Message: TWMPaint);
var
  r: TRect;
  c: TCanvas;
begin
 inherited;
  r.Top := ClientRect.Top+4;
  r.Left := ClientRect.Left+4;
  r.Right := ClientRect.Right-5;
  r.Bottom := ClientRect.Bottom-5;
  c := TCanvas.Create;
  try
  c.Handle := GetDC(Handle);
  if fColor <> clNone then begin
    c.Brush.Color:=fColor;
    c.FillRect(r);
  end else begin
    c.Pen.Color := clRed;
    c.Brush.Color := clWhite;
    c.FillRect(r);
    c.FrameRect(r);
    c.MoveTo(r.Right, r.Top);
    c.LineTo(r.Left, r.Bottom);
  end;
  finally
    c.Free;
  end;
end;

end.