unit ImageLoad;

interface

uses Windows, SysUtils, Classes, Graphics, jpeg, GifImg, pngimage;

function LoadImageFromFile(const PathName: WideString): TGraphic;

implementation

uses wsFileOp;

function CreateStream(const FileName: widestring): TFileStream;
begin
  try
    Result:=TFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
  except
    try
       Result:=TFileStream.Create(FileName, fmOpenRead or fmShareDenyNone);
    except
       Result:=nil;
    end;
  end;
end; 

function LoadImageFromFile(const PathName: WideString): TGraphic;
var
  fs: TFileStream;
  ext: WideString;
begin
  Result := nil;
  fs := CreateStream(PathName);
  try
    ext := CharLowerW(PWChar(ExtractFileExt(PathName)));
    if ext = '.bmp' then begin
      Result := TBitmap.Create;
    end else if (ext = '.jpg') or (ext = '.jpeg') then begin
      Result := TJPEGImage.Create;
    end else if ext = '.gif' then begin
      Result := TGIFImage.Create;
    end else if ext = '.png' then begin
      Result := TPngImage.Create;
    end else exit;
    try
      Result.LoadFromStream(fs);
    except
      Result.Free;
      Result := nil;
    end;
  finally
    fs.Free;
  end;
end;

end.
