{****************************************

  TPropListBox

  Copyright(c) Hayato Sasaki 1995-2000

  E-Mail: QZG01115@nifty.ne.jp

  URL: http://homepage1.nifty.com/wizman/

*****************************************}

unit PLBxCtls;

{
  2000/11/25
  Ver1.0 J

  2000/11/26
  TCustomPropListBox ŃGfB^̃L[Cxg TCustomPropListBox g
  oCpX悤ɂB
  L[͂GfB^ȂꍇAITopIndexXV
  悤ɂB
  XN[o[\ɕωATopIndex 0ɂȂȂoOCB
  Flat=FalsẽGfB^̃TCYvZ~XĂoOCB
  }EXzC[̃T|[gB
  ^uXgbv̋̂CB
}

interface

uses
  Windows, Messages, Classes, Controls, SysUtils, Graphics, StdCtrls, Forms;

type
  TUnknownListBox = class(TWinControl)
  private
    FCanvas: TCanvas;
    FItemCount: Integer;
    FBorderStyle: TBorderStyle;
    FItemHeight: Integer;
    FItemIndex: Integer;
    FMiniDoubleBuffered: Boolean;
    FTopIndex: Integer;
    FRowCount: Integer;
    FViewRowCount: Integer;
    FDragging: Boolean;
    FOldTime: DWORD;
    FScrollCount: Integer;
    function ClipTopIndex(Value: Integer): Integer;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure DoScroll;
    procedure DrawItems;
    procedure DrawItemsOffScreen(DC: HDC);
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetItemHeight(Value: Integer);
    procedure SetItemIndex(Value: Integer);
    procedure SetTopIndex(Value: Integer);
    procedure UpdateMetric;
    procedure UpdateScrollBar;
    procedure WMCaptureChanged(var Message: TMessage); message WM_CAPTURECHANGED;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMTimer(var Message: TWMTimer); message WM_TIMER;
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
  protected
    function CanChangeItemIndex: Boolean; virtual;
    procedure ChangeItemIndex; virtual;
    procedure ChangeTopIndex; virtual;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    //function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    //function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); virtual; abstract;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    property MiniDoubleBuffered: Boolean read FMiniDoubleBuffered write FMiniDoubleBuffered;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure PaintWindow(DC: HDC); override;
    procedure SetItemCount(Value: Integer); virtual;
    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle default bsSingle;
    property ItemCount: Integer read FItemCount write SetItemCount;
    property ItemHeight: Integer read FItemHeight write SetItemHeight;
    property ParentColor default False;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure AbleShowItemIndex;
    function ItemAtPos(Pos: TPoint; Existing: Boolean): Integer;
    function ItemRect(Index: Integer): TRect;
    property Canvas: TCanvas read FCanvas;
    property ItemIndex: Integer read FItemIndex write SetItemIndex;
    property TopIndex: Integer read FTopIndex write SetTopIndex;
  published
    property TabStop default True;
  end;

  {
    RefreshData \bh
    f[^tbV܂B
  }
  TStackListBox = class(TUnknownListBox)
  private
    FFlat: Boolean;
    FMinSize: Integer;
    FSpliter: Integer;
    FSplitting: Boolean;
    FEditControl: TWinControl;
    procedure AdjustEditControl;
    function ClipSpliter(Value: Integer): Integer;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    function GetEditArea: TRect;
    function IsSpliterArea(X: Integer): Boolean;
    procedure SetFlat(Value: Boolean);
    procedure SetMinSize(Value: Integer);
    procedure SetSpliter(Value: Integer);
    procedure WMCaptureChanged(var Message: TMessage); message WM_CAPTURECHANGED;
  protected
    procedure ChangeItemIndex; override;
    procedure ChangeSpliter; virtual;
    procedure ChangeTopIndex; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure DrawItemText(Index: Integer; LRect, RRect: TRect; State: TOwnerDrawState); virtual;
    procedure FreeEditControl(Control: TWinControl); virtual; abstract;
    procedure GetEditControl(Index: Integer; var Control: TWinControl); virtual; abstract;
    procedure GetItemString(Index: Integer; var LeftCaption, RightCaption: string); virtual;
    procedure GetItemColor(Index: Integer; var LeftColor, RightColor: TColor); virtual;
    procedure InitItemHeight; virtual;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure Resize; override;
    property EditControl: TWinControl read FEditControl;
    property Flat: Boolean read FFlat write SetFlat;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure RefreshData;
    procedure SetFocus; override;
    property MinSize: Integer read FMinSize write SetMinSize default 0;
    property Spliter: Integer read FSpliter write SetSpliter;
  end;


  TReferButton = class(TGraphicControl)
  private
    FPress: Boolean;
    FPushing: Boolean;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Paint; override;
    procedure ReleaseCapture;
    property Press: Boolean read FPress;
    property Pushing: Boolean read FPushing;
  public
    constructor Create(AOwner: TComponent); override;
  end;


  TROComboBox = class(TComboBox)
  private
    FReadOnly: Boolean;
    procedure SetReadOnly(Value: Boolean);
  protected
    procedure CreateWnd; override;
    property ReadOnly: Boolean read FReadOnly write SetReadOnly;
  end;


  TNBComboBox = class(TWinControl)
  private
    FComboBox: TComboBox;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Resize; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Focused: Boolean; override;
    procedure SetFocus; override;
    property ComboBox: TComboBox read FComboBox;
  end;

  {
    psEdit
      GfBbg{bNX̂
    psDropDown
      hbv_EXg̃R{{bNX
    psRefer
      {^t̃GfBbg{bNX
  }
  TPropEditStyle = (psEdit, psDropDown, psRefer);

  TCustomPropEdit = class(TCustomControl)
  private
    FBorderStyle: TBorderStyle;
    FLabelCaption: string;
    FLeftColor: TColor;
    FRightColor: TColor;
    FModified: Boolean;
    FReadOnly: Boolean;
    FSpliter: Integer;
    FStyle: TPropEditStyle;
    FEdit: TEdit;
    FButton: TReferButton;
    FComboBox: TNBComboBox;
    FOnRefer: TNotifyEvent;
    procedure AdjustEditControl;
    procedure ClickReferButton(Sender: TObject);
    procedure ComboBoxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBoxKeyPress(Sender: TObject; var Key: Char);
    //procedure ComboBoxMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    //procedure ComboBoxMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);

    procedure EditChange(Sender: TObject);
    procedure EditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure EditKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    //procedure EditMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    //procedure EditMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);

    function GetDropDownCount: Integer;
    function GetItemHeight: Integer;
    function GetItems: TStrings;
    function GetText: string;
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetDropDownCount(Value: Integer);
    procedure SetItems(Value: TStrings);
    procedure SetLabelCaption(Value: string);
    procedure SetReadOnly(Value: Boolean);
    procedure SetSpliter(Value: Integer);
    procedure SetStyle(Value: TPropEditStyle);
    procedure SetText(Value: string);
    procedure WMCaptureChanged(var Message: TMessage); message WM_CAPTURECHANGED;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
    procedure SetLeftColor(const Value: TColor);
    procedure SetRightColor(const Value: TColor);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;

    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;

    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Paint; override;
    procedure Resize; override;
    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle default bsSingle;
    property DropDownCount: Integer read GetDropDownCount write SetDropDownCount;
    property ReadOnly: Boolean read FReadOnly write SetReadOnly;
    property Style: TPropEditStyle read FStyle write SetStyle default psEdit;
    property OnRefer: TNotifyEvent read FOnRefer write FOnRefer;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Focused: Boolean; override;
    procedure SetFocus; override;
    property ItemHeight: Integer read GetItemHeight;
    property Items: TStrings read GetItems write SetItems;
    property Modified: Boolean read FModified write FModified;
    property LabelCaption: string read FLabelCaption write SetLabelCaption;
    property Spliter: Integer read FSpliter write SetSpliter default 0;
    property Text: string read GetText write SetText;
    property LeftColor:TColor read FLeftColor write SetLeftColor;
    property RightColor:TColor read FRightColor write SetRightColor;
  end;


  PPropItem = ^TPropItem;
  TPropItem = record
    LanelCaption: string;  //ڂ̍̃x
    ValueCaption: string;  //ڂ̉E̒l
    Style: TPropEditStyle; //GfB^̃X^C
    ReadOnly: Boolean;     //True ̎[U[͒ڕҏWłȂ
    LeftColor: TColor;
    RightColor:Tcolor;
  end;


  TPLBDataEvent = procedure (Sender: TObject; Index: Integer; var Item: TPropItem) of object;
  TPLBReferEvent = procedure (Sender: TObject; Index: Integer) of object;
  TPLBDropDownEvent = procedure (Sender: TObject; Index: Integer; List: TStrings) of object;
  TPLBCheckEvent = procedure (Sender: TObject; Index: Integer; var CanUpdate: Boolean) of object;
  TPLBUpdateEvent = procedure (Sender: TObject; Index: Integer) of object;

  {
    TCustomPropListBox ̓eLXg\T|[g{NXłB
    f[^͕ێ܂BCxgŃf[^KvȎ̃f[^ݒ肵܂B


    CheckData \bh
    IɃf[^̃`FbNs܂
    


    DropDownCount vpeB
    hbv_EXg̐ł

    EditText vpeB
    ҏW̃eLXgł


    OnChange Cxg
    ItemIndex vpeBω܂

    OnChangeSpliter Cxg
    Spliter vpeBω܂

    OnCheck Cxg
    [U[ݒ肵eLXgǂ`FbN鎞܂B
    ̃^C~OŃ`FbNsł܂B
    Ȃ CanUpdate = False ɐݒ肷΁AXVLZ܂B

    OnData Cxg
    f[^KvȎ܂B
    ̃^C~OŁAItem ̃tB[h鎖ł܂B

    OnDropDown Cxg
    f[^ psDropDown Ńhbv_EXgKvȎ܂B
    List ̃hbv_EXg̓eݒ肵ĂB

    OnRefer Cxg
    f[^ psRefer Ń{^ꂽ܂B

    OnUpdate Cxg
    f[^̍XVKvȎ܂B
  }
  TCustomPropListBox = class(TStackListBox)
  private
    FPropEdit: TCustomPropEdit;
    FDropDownCount: Integer;
    FOnChange: TNotifyEvent;
    FOnChangeSpliter: TNotifyEvent;
    FOnCheck: TPLBCheckEvent;
    FOnData: TPLBDataEvent;
    FOnDropDown: TPLBDropDownEvent;
    FOnRefer: TPLBReferEvent;
    FOnUpdate: TPLBUpdateEvent;

    FSaveOnChange: TNotifyEvent;

    procedure ClickReferButton(Sender: TObject);
    function GetDropDownCount: Integer;
    function GetEditText: string;
    procedure SetDropDownCount(Value: Integer);
    procedure SetEditText(Value: string);

    procedure CloseUp(Sender: TObject);

  protected
    function CanChangeItemIndex: Boolean; override;
    procedure ChangeItemIndex; override;
    procedure ChangeSpliter; override;
    procedure CreateWnd; override;
    procedure DrawItemText(Index: Integer; LRect, RRect: TRect; State: TOwnerDrawState); override;
    procedure FreeEditControl(Control: TWinControl); override;
    procedure GetData(Index: Integer; var Item: TPropItem); virtual;
    procedure GetEditControl(Index: Integer; var Control: TWinControl); override;
    procedure GetItemString(Index: Integer; var LeftCaption, RightCaption: string); override;
    procedure GetItemColor(Index: Integer; var LeftColor, RightColor: TColor); override;
    procedure InitItemHeight; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    property DropDownCount: Integer read GetDropDownCount write SetDropDownCount;
    property EditText: string read GetEditText write SetEditText;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnChangeSpliter: TNotifyEvent read FOnChangeSpliter write FOnChangeSpliter;
    property OnCheck: TPLBCheckEvent read FOnCheck write FOnCheck;
    property OnData: TPLBDataEvent read FOnData write FOnData;
    property OnDropDown: TPLBDropDownEvent read FOnDropDown write FOnDropDown;
    property OnRefer: TPLBReferEvent read FOnRefer write FOnRefer;
    property OnUpdate: TPLBUpdateEvent read FOnUpdate write FOnUpdate;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function CheckData: Boolean;
    //function Focused: Boolean; override;
  end;

  TPropListBox = class(TCustomPropListBox)
  public
    property EditText;
    property ItemCount;
  published
    property Align;
    property Anchors;
    property BiDiMode;
    property BorderStyle;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property DropDownCount;
    property Enabled;
    property Flat;
    property Font;
    property ImeMode;
    property ImeName;
    property MiniDoubleBuffered;
    property MinSize;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Spliter;
    property TabOrder;
    property Visible;
    property OnChange;
    property OnChangeSpliter;
    property OnCheck;
    property OnContextPopup;
    property OnData;
    property OnDropDown;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnRefer;
    property OnResize;
    property OnUpdate;
  end;

implementation

uses
  Consts, types;

const
  TIMER_ID = $FFFF;

type
  TWinControlAccess = class(TWinControl);

//TUnknownListBox

constructor TUnknownListBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csCaptureMouse, csDoubleClicks, csClickEvents, csOpaque];

  FCanvas := TControlCanvas.Create;
  TControlCanvas(FCanvas).Control := Self;

  Width := 121;
  Height := 97;
  TabStop := True;
  ParentColor := False;

  FItemIndex := -1;

  FItemHeight := 16;
  FBorderStyle := bsSingle;
end;

destructor TUnknownListBox.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
end;

function TUnknownListBox.ClipTopIndex(Value: Integer): Integer;
begin
  if (FItemCount <= FRowCount) or (Value < 0) then
    Result := 0
  else if Value > FItemCount - FRowCount then
    Result := FItemCount - FRowCount
  else
    Result := Value;
end;

procedure TUnknownListBox.CMCtl3DChanged(var Message: TMessage);
begin
  if NewStyleControls and (FBorderStyle = bsSingle) then
    RecreateWnd;
  inherited;
end;

procedure TUnknownListBox.DoScroll;
const
  PreciseValue = 256;
var
  P: TPoint;
  Scroll, Cnt: Integer;
  NewTime: DWORD;
begin
  if not GetCursorPos(P) then
    Exit;

  P := ScreenToClient(P);

  if P.y < 0 then
    Scroll := (P.y + 1) div FItemHeight - 1
  else if P.y >= ClientHeight then
    Scroll := (P.y - ClientHeight - 1) div FItemHeight + 1
  else
    begin
      FOldTime := GetTickCount;
      FScrollCount := 0;
      Exit;
    end;

  if Scroll > 0 then
    if Scroll < 8 then
      Scroll := 1 shl (Scroll - 1)
    else
      Scroll := 256
  else
    if Scroll > -8 then
      Scroll := -(1 shl (-Scroll-1))
    else
      Scroll := -256;

  Scroll := Scroll * PreciseValue;
  NewTime := GetTickCount;
  Cnt := (Integer(NewTime - FOldTime) * Scroll) div 500;
  FOldTime := NewTime;

  Inc(FScrollCount, Cnt);

  if Scroll > 0 then
    begin
      if FScrollCount < 0 then
        FScrollCount := 0;
    end
  else
    begin
      if FScrollCount > 0 then
        FScrollCount := 0;
    end;

  Inc(FScrollCount, Cnt);

  Cnt := FScrollCount div PreciseValue;

  if Cnt = 0 then
    Exit;

  Dec(FScrollCount, Cnt * PreciseValue);

  Scroll := ClipTopIndex(FTopIndex + Cnt);

  if not CanChangeItemIndex then
    Exit;

  //LockWindowUpdate(Handle);

  if Cnt < 0 then
    SetItemIndex(Scroll)
  else
    begin
      Cnt := Scroll;
      Inc(Cnt, FViewRowCount - 1);
      if Cnt >= FItemCount then
        Cnt := FItemCount - 1;
      SetItemIndex(Cnt);
    end;

  SetTopIndex(Scroll);

  //LockWindowUpdate(0);
end;

procedure TUnknownListBox.DrawItems;
var
  Index, H: Integer;
  ARect: TRect;
begin
  Index := FTopIndex;

  H := ClientHeight;

  ARect.Top := 0;
  ARect.Left := 0;
  ARect.Right := ClientWidth;
  ARect.Bottom := FItemHeight;

  while ARect.Top < H do
  begin
    if Index = FItemCount then
      Break;

    FCanvas.Brush := Brush;
    FCanvas.Font  := Font;

    if FItemIndex = Index then
      if Focused then
        DrawItem(Index, ARect, [odSelected, odFocused])
      else
        DrawItem(Index, ARect, [odSelected])
    else
      DrawItem(Index, ARect, []);

    Inc(ARect.Top, FItemHeight);
    Inc(ARect.Bottom, FItemHeight);

    Inc(Index);
  end;

  if ARect.Top < H then
    begin
      FCanvas.Brush := Brush;
      ARect.Bottom := H;
      FCanvas.FillRect(ARect);
    end;
end;

procedure TUnknownListBox.DrawItemsOffScreen(DC: HDC);
var
  Index, H, Y, W: Integer;
  ARect: TRect;
  Bitmap: TBitmap;
  SaveCanvas: TCanvas;
begin
  Index := FTopIndex;

  W := ClientWidth;
  H := ClientHeight;

  ARect.Top := 0;
  ARect.Left := 0;
  ARect.Right := W;
  ARect.Bottom := FItemHeight;

  Y := 0;

  if FItemCount > 0 then
    begin
      Bitmap := TBitmap.Create;
      Bitmap.Width := W;
      Bitmap.Height := FItemHeight;

      SaveCanvas := FCanvas;
      FCanvas := Bitmap.Canvas;

      try
        while Y < H do
        begin
          if Index = FItemCount then
            Break;

          FCanvas.Brush := Brush;
          FCanvas.Font  := Font;

          if FItemIndex = Index then
            if Focused then
              DrawItem(Index, ARect, [odSelected, odFocused])
            else
              DrawItem(Index, ARect, [odSelected])
          else
            DrawItem(Index, ARect, []);

          BitBlt(DC, 0, Y, W, FItemHeight, FCanvas.Handle, 0, 0, SRCCOPY);

          Inc(Y, FItemHeight);

          Inc(Index);
        end;
      finally
        FCanvas := SaveCanvas;
        Bitmap.Free;
      end;
    end;

  if Y >= H then
    Exit;

  FCanvas.Handle := DC;
  try
    FCanvas.Brush := Brush;
    ARect.Top := Y;
    ARect.Bottom := H;
    FCanvas.FillRect(ARect);
  finally
    FCanvas.Handle := 0;
  end;
end;

procedure TUnknownListBox.SetBorderStyle(Value: TBorderStyle);
begin
  if FBorderStyle <> Value then
    begin
      FBorderStyle := Value;
      ControlStyle := ControlStyle + [csFramed];
      RecreateWnd;
    end;
end;

procedure TUnknownListBox.SetItemHeight(Value: Integer);
begin
  if (FItemHeight <> Value) and (Value > 0) then
    begin
      FItemHeight := Value;
      UpdateMetric;
    end;
end;

procedure TUnknownListBox.SetItemIndex(Value: Integer);
begin
  if not CanChangeItemIndex then
    Exit;

  if (Value < 0) or (Value >= FItemCount) then
    Value := -1;

  if FItemIndex <> Value then
    begin
      FItemIndex := Value;
      ChangeItemIndex;
      Invalidate;
    end;
end;

procedure TUnknownListBox.SetTopIndex(Value: Integer);
begin
  Value := ClipTopIndex(Value);

  if FTopIndex <> Value then
    begin
      //Scroll := (FTopIndex - Value) * FItemHeight;
      FTopIndex := Value;
      SetScrollPos(Handle, SB_VERT, FTopIndex, True);
      //ScrollWindowEx(Handle, 0, Scroll, nil, nil, 0, nil, SW_INVALIDATE);
      ChangeTopIndex;
      Invalidate;
    end;
end;

procedure TUnknownListBox.UpdateMetric;
var
  NewRowCount: Integer;
begin
  if not HandleAllocated then
    Exit;

  NewRowCount := ClientHeight div FItemHeight;
  if FRowCount <> NewRowCount then
    begin
      FRowCount := NewRowCount;
      FViewRowCount := FRowCount;
      if FRowCount * FItemHeight < ClientHeight then
        Inc(FViewRowCount);
      UpdateScrollBar;
    end;
end;

procedure TUnknownListBox.UpdateScrollBar;
var
  Info: TScrollInfo;
begin
  if not HandleAllocated then
    Exit;

  if FItemCount <= FRowCount then
    begin
      if FTopIndex > 0 then
        begin
          FTopIndex := 0;
          ChangeTopIndex;
        end;
      ShowScrollBar(Handle, SB_VERT, False);
    end
  else
    begin
      if FTopIndex > FItemCount - FRowCount then
        begin
          FTopIndex := FItemCount - FRowCount;
          ChangeTopIndex;
        end;

      with Info do
      begin
        cbSize := SizeOf(TScrollInfo);
        fMask  := SIF_RANGE or SIF_PAGE or SIF_POS;
        nMin   := 0;
        nMax   := FItemCount - 1;
        nPage  := FRowCount;
        nPos   := FTopIndex;
        nTrackPos := 0;
      end;

      SetScrollInfo(Handle, SB_VERT, Info, True);

      ShowScrollBar(Handle, SB_VERT, True);
    end;
end;

procedure TUnknownListBox.WMCaptureChanged(var Message: TMessage);
begin
  inherited;

  if not FDragging then
    Exit;

  FDragging := False;
  KillTimer(Handle, TIMER_ID);
end;

procedure TUnknownListBox.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 0;
end;

procedure TUnknownListBox.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTALLKEYS or DLGC_WANTARROWS or DLGC_WANTCHARS	or DLGC_WANTMESSAGE {or DLGC_WANTTAB};
end;

procedure TUnknownListBox.WMPaint(var Message: TWMPaint);
begin
  ControlState := ControlState + [csCustomPaint];
  inherited;
  ControlState := ControlState - [csCustomPaint];
end;

procedure TUnknownListBox.WMSize(var Message: TWMSize);
begin
  inherited;
  UpdateMetric;
end;

procedure TUnknownListBox.WMTimer(var Message: TWMTimer);
begin
  if Message.TimerID = TIMER_ID then
    DoScroll
  else
    inherited;
end;

procedure TUnknownListBox.WMVScroll(var Message: TWMVScroll);
var
  NewPos: Longint;
  ScrollInfo: TScrollInfo;
begin
  with Message do
  begin
    NewPos := FTopIndex;
    case TScrollCode(ScrollCode) of
      scLineUp:
        Dec(NewPos);
      scLineDown:
        Inc(NewPos);
      scPageUp:
        Dec(NewPos, FRowCount);
      scPageDown:
        Inc(NewPos, FRowCount);
      scPosition, scTrack:
        with ScrollInfo do
        begin
          cbSize := SizeOf(ScrollInfo);
          fMask := SIF_TRACKPOS;
          GetScrollInfo(Handle, SB_VERT, ScrollInfo);
          NewPos := nTrackPos;
        end;
      scTop:
        NewPos := 0;
      scBottom:
        NewPos := FItemCount - FRowCount;
    end;

    SetTopIndex(NewPos);
  end;
end;

function TUnknownListBox.CanChangeItemIndex: Boolean;
begin
  Result := True;
end;

procedure TUnknownListBox.ChangeItemIndex;
begin
end;

procedure TUnknownListBox.ChangeTopIndex;
begin
end;

procedure TUnknownListBox.CreateParams(var Params: TCreateParams);
const
  BorderStyles: array[TBorderStyle] of DWORD = (0, WS_BORDER);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    Style := Style or WS_CLIPCHILDREN or BorderStyles[FBorderStyle];
    if NewStyleControls and Ctl3D and (FBorderStyle = bsSingle) then
    begin
      Style := Style and not WS_BORDER;
      ExStyle := ExStyle or WS_EX_CLIENTEDGE;
    end;
  end;
end;

procedure TUnknownListBox.CreateWnd;
begin
  inherited CreateWnd;
  UpdateScrollBar;
end;
{
function TUnknownListBox.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelDown(Shift, MousePos);

  if Result then
    Exit;

  Result := True;
end;

function TUnknownListBox.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelUp(Shift, MousePos);

  if Result then
    Exit;

  Result := True;
end;
}
procedure TUnknownListBox.KeyDown(var Key: Word; Shift: TShiftState);
var
  Index: Integer;
begin
  inherited;

  case Key of
    VK_UP:
      begin
        if FItemIndex > 0 then
          SetItemIndex(FItemIndex - 1);
      end;
    VK_DOWN:
      begin
        if FItemIndex < FItemCount - 1 then
          SetItemIndex(FItemIndex + 1);
      end;
    VK_PRIOR:
      begin
        Index := FItemIndex - FRowCount;
        if Index < 0 then
          Index := 0;
        SetItemIndex(Index);
      end;
    VK_NEXT:
      begin
        Index := FItemIndex + FRowCount;
        if Index >= FItemCount then
          Index := FItemCount - 1;
        SetItemIndex(Index);
      end;
  end;

  if Key <> 0 then
    AbleShowItemIndex;
end;

procedure TUnknownListBox.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Index: Integer;
begin
  inherited;

  SetFocus;

  if (Button = mbLeft) and (Shift = [ssLeft]) then
    begin
      Index := ItemAtPos(Point(X, Y), True);
      if Index < 0 then
        Exit;

      SetItemIndex(Index);

      FDragging := True;

      FScrollCount := 0;
      FOldTime := GetTickCount;
      SetTimer(Handle, TIMER_ID, 100, nil);
    end;
end;

procedure TUnknownListBox.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  Index: Integer;
begin
  inherited;

  if not FDragging then
    Exit;

  Index := ItemAtPos(Point(X, Y), True);
  if Index >= 0 then
    SetItemIndex(Index);
end;

procedure TUnknownListBox.PaintWindow(DC: HDC);
begin
  if (WindowFromDC(DC) = 0) or (not FMiniDoubleBuffered) then
    begin
      FCanvas.Lock;
      try
        FCanvas.Handle := DC;
        try
          DrawItems;
        finally
          FCanvas.Handle := 0;
        end;
      finally
        FCanvas.Unlock;
      end;
    end
  else
    DrawItemsOffScreen(DC);
end;

procedure TUnknownListBox.SetItemCount(Value: Integer);
begin
  if (FItemCount <> Value) and (Value >= 0) then
    begin
      FItemCount := Value;
      UpdateScrollBar;
      SetItemIndex(FItemIndex);
    end;
end;

procedure TUnknownListBox.AbleShowItemIndex;
begin
  if FItemIndex < FTopIndex then
    SetTopIndex(FItemIndex)
  else if FItemIndex >= FTopIndex + FRowCount then
    SetTopIndex(FItemIndex - FRowCount + 1);
end;

function TUnknownListBox.ItemAtPos(Pos: TPoint; Existing: Boolean): Integer;
begin
  //if (Pos.x >= 0) and (Pos.x < ClientWidth) then
  if (Pos.y >= 0) and (Pos.y < ClientHeight) then
    begin
      Result := FTopIndex + Pos.y div FItemHeight;
      if Result < 0 then
        Result := -1
      else if Result >= FItemCount then
        if Existing then
          Result := -1
        else
          Result := FItemCount - 1;
    end
  else
    Result := -1;
end;

function TUnknownListBox.ItemRect(Index: Integer): TRect;
begin
  if (Index >= 0) and (Index < FItemCount) then
    begin
      Result.Left := 0;
      Result.Top := FItemHeight * (Index - FTopIndex);
      Result.Right := ClientWidth;
      Result.Bottom := Result.Top;
      Inc(Result.Bottom);
    end
  else
    FillChar(Result, SizeOf(Result), 0);
end;

//TStackListBox

constructor TStackListBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSpliter := Width div 2;
  Color := clBtnFace;
  InitItemHeight;
end;

destructor TStackListBox.Destroy;
begin
  if FEditControl <> nil then
    FreeEditControl(FEditControl);
  inherited Destroy;
end;

procedure TStackListBox.AdjustEditControl;
var
  ARect: TRect;
begin
  if FEditControl = nil then
    Exit;
  ARect := GetEditArea;
  FEditControl.SetBounds(ARect.Left, ARect.Top,
    ARect.Right - ARect.Left, ARect.Bottom - ARect.Top);
end;

function TStackListBox.ClipSpliter(Value: Integer): Integer;
begin
  if Value < 0 then
    Result := 0
  else if Value >= ClientWidth then
    Result := ClientWidth - 1
  else
    Result := Value;
end;

procedure TStackListBox.CMFontChanged(var Message: TMessage);
begin
  inherited;
  InitItemHeight;
end;

function TStackListBox.GetEditArea: TRect;
begin
  Result.Left := 0;
  Result.Top  := (FItemIndex - FTopIndex) * FItemHeight;
  Result.Right  := Result.Left + ClientWidth;
  Result.Bottom := Result.Top  + FItemHeight;

  Dec(Result.Left, 2);
  Inc(Result.Right, 2);

  if FFlat then
    begin
      Dec(Result.Top, 2);
      Inc(Result.Bottom);
    end
  else
    begin
      Dec(Result.Top);
      Inc(Result.Bottom);
    end;
end;

function TStackListBox.IsSpliterArea(X: Integer): Boolean;
begin
  Result := (X >= FSpliter - 2) and (X <= FSpliter + 1);
end;

procedure TStackListBox.SetFlat(Value: Boolean);
begin
  if FFlat <> Value then
    begin
      FFlat := Value;
      InitItemHeight;
      Invalidate;
    end;
end;

procedure TStackListBox.SetMinSize(Value: Integer);
begin
  if (FMinSize <> Value) and (Value >= 0) then
    begin
      FMinSize := Value;
      SetSpliter(FSpliter);
    end;
end;

procedure TStackListBox.SetSpliter(Value: Integer);
begin
  if Value >= ClientWidth - FMinSize then
    Value := ClientWidth - FMinSize - 1;

  if Value < FMinSize then
    Value := FMinSize;

  if FSpliter <> Value then
    begin
      FSpliter := Value;
      ChangeSpliter;
      AdjustEditControl;
      Invalidate;
    end;
end;

procedure TStackListBox.WMCaptureChanged(var Message: TMessage);
begin
  inherited;

  if FSplitting then
    FSplitting := False;
end;

procedure TStackListBox.ChangeItemIndex;
var
  f: Boolean;
begin
  if FEditControl <> nil then
    begin
      f := FEditControl.Focused;
      FreeEditControl(FEditControl);
      FEditControl := nil;
    end
  else
    f := Focused;

  if FItemIndex < 0 then
    Exit;

  GetEditControl(FItemIndex, FEditControl);

  if FEditControl <> nil then
    begin
      FEditControl.Visible := False;
      FEditControl.Parent := Self;
      AdjustEditControl;
      FEditControl.Visible := True;
      if f then
        FEditControl.SetFocus;
    end;
end;

procedure TStackListBox.ChangeSpliter;
begin
end;

procedure TStackListBox.ChangeTopIndex;
begin
  AdjustEditControl;
end;

procedure TStackListBox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  LRect, RRect: TRect;
begin
  LRect.Left := Rect.Left;
  LRect.Top  := Rect.Top;
  LRect.Right := FSpliter;
  LRect.Bottom := Rect.Bottom;

  RRect.Left := FSpliter;
  RRect.Top  := Rect.Top;
  RRect.Right := Rect.Right;
  RRect.Bottom := Rect.Bottom;

  with Canvas do
  if FFlat then
    if odSelected in State then
      begin
        Dec(LRect.Bottom);
        FillRect(LRect);

        Dec(RRect.Bottom);
        Brush.Color := clWindow;
        FillRect(RRect);

        DrawEdge(Handle, Rect, BDR_SUNKENINNER, BF_BOTTOM);
      end
    else
      begin
        Dec(Rect.Bottom);
        FillRect(Rect);

        DrawEdge(Handle, LRect, BDR_RAISEDINNER, BF_BOTTOM or BF_RIGHT);
        DrawEdge(Handle, RRect, BDR_RAISEDINNER, BF_BOTTOM or BF_LEFT);
        Dec(LRect.Bottom);
        Dec(RRect.Bottom);
      end
  else
    if odSelected in State then
      begin
        Inc(LRect.Top);
        Dec(LRect.Bottom);

        FillRect(LRect);

        Inc(RRect.Top);
        Dec(RRect.Bottom);

        Brush.Color := clWindow;
        FillRect(RRect);

        if Index < FItemCount - 1 then
          DrawEdge(Handle, Rect, BDR_SUNKENINNER, BF_TOP or BF_BOTTOM)
        else
          DrawEdge(Handle, Rect, BDR_SUNKENOUTER, BF_TOP or BF_BOTTOM or BF_SOFT);
      end
    else
      begin
        Inc(Rect.Top);
        Dec(Rect.Bottom);
        FillRect(Rect);

        DrawEdge(Handle, LRect, BDR_RAISEDINNER, BF_TOP or BF_BOTTOM or BF_RIGHT);
        DrawEdge(Handle, RRect, BDR_RAISEDINNER, BF_TOP or BF_BOTTOM or BF_LEFT);

        Inc(LRect.Top);
        Dec(LRect.Bottom);
        Inc(RRect.Top);
        Dec(RRect.Bottom);
      end;

  DrawItemText(Index, LRect, RRect, State);
end;

procedure TStackListBox.DrawItemText(Index: Integer; LRect, RRect: TRect; State: TOwnerDrawState);
var
  LeftCaption, RightCaption: string;
  L: Integer;
  C0, C1, C2: TColor;
begin
  GetItemString(Index, LeftCaption, RightCaption);
  GetItemColor(Index, C1, C2);
  with Canvas do
  begin
    Brush.Style := bsClear;
    C0 := Font.Color;
    if C1 <> clNone then Font.Color := C1;
    L := Length(LeftCaption);
    if L > 0 then
      begin
        Inc(LRect.Left);
        DrawText(Handle, PChar(LeftCaption), L, LRect,
          DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX or DT_END_ELLIPSIS);
      end;
    Font.Color := C0;

    if odSelected in State then
      Exit;

    if C2 <> clNone then Font.Color := C2;
    L := Length(RightCaption);
    if L > 0 then
      begin
        Inc(RRect.Left, 2);
        DrawText(Handle, PChar(RightCaption), L, RRect,
          DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX or DT_END_ELLIPSIS);
      end;
    Font.Color := C0;
  end
end;

procedure TStackListBox.GetItemString(Index: Integer; var LeftCaption, RightCaption: string);
begin
  LeftCaption := IntToStr(Index);
  RightCaption := IntToStr(Index);
end;

procedure TStackListBox.InitItemHeight;
var
  DC: THandle;
  SaveFont: THandle;
  Size: TSize;
begin
  DC := CreateCompatibleDC(0);
  try
    SaveFont := SelectObject(DC, Font.Handle);
    try
      if GetTextExtentPoint32(DC, '0', 1, Size) then
        ItemHeight := Size.cy;
    finally
      SelectObject(DC, SaveFont);
    end;
  finally
    DeleteDC(DC);
  end;
end;

procedure TStackListBox.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and (Shift = [ssLeft]) and IsSpliterArea(X) then
    begin
      SetFocus;
      FSplitting := True;
    end
  else
    inherited;
end;

procedure TStackListBox.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;

  if FSplitting then
    SetSpliter(ClipSpliter(X))
  else
    if IsSpliterArea(X) then
      Cursor := crHSplit
    else
      Cursor := crDefault;
end;

procedure TStackListBox.Resize;
begin
  inherited;
  SetSpliter(FSpliter);
  AdjustEditControl;
  Invalidate;
end;

procedure TStackListBox.RefreshData;
begin
  ChangeItemIndex;
  Invalidate;
end;

procedure TStackListBox.SetFocus;
begin
  inherited;
  if FEditControl <> nil then
    FEditControl.SetFocus;
end;

//TReferButton

constructor TReferButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csCaptureMouse, csOpaque];
end;

procedure TReferButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    begin
      FPushing := True;
      FPress := True;
      Invalidate;
    end;
  inherited;
end;

procedure TReferButton.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  NewPress: Boolean;
begin
  if FPushing then
    begin
      NewPress := PtInRect(ClientRect, Point(X, Y));
      if FPress <> NewPress then
        begin
          FPress := NewPress;
          Invalidate;
        end;
    end;
  inherited;
end;

procedure TReferButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    ReleaseCapture;
  inherited;
end;

procedure TReferButton.Paint;
var
  ARect: TRect;
  W, Dot, i, X, Y: Integer;
begin
  with Canvas do
  begin
    ARect := ClientRect;
    W := ARect.Right - ARect.Left - 4;
    Dot := W div 3 - 2;
    if Dot <= 0 then
      Dot := 1;
    W := Dot * 2;

    X := (ARect.Left + ARect.Right - (Dot * 5)) div 2;
    Y := (ARect.Top + ARect.Bottom - Dot) div 2;

    if FPress then
      begin
        DrawEdge(Handle, ARect, BDR_RAISEDOUTER, BF_RECT or BF_FLAT);
        InflateRect(ARect, -1, -1);
        Inc(X);
        Inc(Y);
      end
    else
      begin
        DrawEdge(Handle, ARect, EDGE_RAISED, BF_RECT);
        InflateRect(ARect, -2, -2);
      end;

    Brush.Color := clBtnFace;
    FillRect(ARect);

    Brush.Color := clBtnText;

    for i := 0 to 2 do
      begin
        Ellipse(X, Y, X + Dot, Y + Dot);
        Inc(X, W);
      end;
  end;
end;

procedure TReferButton.ReleaseCapture;
var
  P: TPoint;
begin
  if FPushing then
    begin
      FPushing := False;
      if FPress then
        begin
          FPress := False;
          Invalidate;
        end;

      GetCursorPos(P);

      if PtInRect(ClientRect, ScreenToClient(P)) then
        Click;
    end;
end;

//TROComboBox

procedure TROComboBox.SetReadOnly(Value: Boolean);
begin
  if FReadOnly <> Value then
    begin
      FReadOnly := Value;
      if HandleAllocated then
        SendMessage(EditHandle, EM_SETREADONLY, Ord(Value), 0);
    end;
end;

procedure TROComboBox.CreateWnd;
begin
  inherited;
  if FReadOnly then
    SendMessage(EditHandle, EM_SETREADONLY, Ord(True), 0);
end;

//TNBComboBox

constructor TNBComboBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [];
  FComboBox := TROComboBox.Create(Self);
  FComboBox.Style := csDropDownList;
  FComboBox.AutoComplete := false;
  FComboBox.Parent := Self;
  FComboBox.TabStop := False;
end;

destructor TNBComboBox.Destroy;
begin
  FComboBox.Free;
  inherited Destroy;
end;

procedure TNBComboBox.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 0;
end;

procedure TNBComboBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  Style := Style or WS_CLIPCHILDREN;
end;

procedure TNBComboBox.Resize;
var
  ARect: TRect;
begin
  inherited;
  ARect := ClientRect;
  InflateRect(ARect, 2, 2);
  FComboBox.SetBounds(ARect.Left, ARect.Top, ARect.Right - ARect.Left, ARect.Bottom - ARect.Top);
end;

function TNBComboBox.Focused: Boolean;
begin
  Result := FComboBox.Focused;
end;

procedure TNBComboBox.SetFocus;
begin
  inherited;
  FComboBox.SetFocus;
end;

//TCustomPropEdit

constructor TCustomPropEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csClickEvents, csOpaque];
  FBorderStyle := bsSingle;
  DoubleBuffered := True;

  FEdit := TEdit.Create(Self);
  with FEdit do
  begin
    Ctl3D := False;
    ParentCtl3D := False;
    BorderStyle := bsNone;
    TabStop := False;
    Parent := Self;
    OnKeyDown  := EditKeyDown;
    OnKeyPress := EditKeyPress;
    OnKeyUp    := EditKeyUp;
    OnChange   := EditChange;

    //TWinControlAccess(FEdit).OnMouseWheelDown := EditMouseWheelDown;
    //TWinControlAccess(FEdit).OnMouseWheelUp   := EditMouseWheelUp;
  end;

  FButton := TReferButton.Create(Self);
  with FButton do
  begin
    Visible := False;
    Parent := Self;
    OnClick := ClickReferButton;
  end;

  FComboBox := TNBComboBox.Create(Self);
  with FComboBox do
  begin
    Visible := False;
    Parent := Self;
    with ComboBox do
    begin
      OnKeyDown  := ComboBoxKeyDown;
      OnKeyPress := ComboBoxKeyPress;
      OnKeyUp    := EditKeyUp;
      OnChange   := EditChange;
      //TWinControlAccess(ComboBox).OnMouseWheelDown := ComboBoxMouseWheelDown;
      //TWinControlAccess(ComboBox).OnMouseWheelUp   := ComboBoxMouseWheelUp;
    end;
  end;
end;

destructor TCustomPropEdit.Destroy;
begin
  FComboBox.Free;
  FButton.Free;
  FEdit.Free;
  inherited Destroy;
end;

procedure TCustomPropEdit.AdjustEditControl;
var
  W, H, BW: Integer;
begin
  if not HandleAllocated then
    Exit;

  W := ClientWidth;
  H := ClientHeight;

  case FStyle of
    psEdit:
      begin
        FEdit.SetBounds(FSpliter + 1, 1, W - FSpliter - 1, H - 2);
      end;
    psDropDown:
      begin
        FComboBox.SetBounds(FSpliter, 0, W - FSpliter, H);
      end
    else //psRefer:
      begin
        BW := GetSystemMetrics(SM_CXVSCROLL);
        FButton.SetBounds(W - BW, 0, BW, H);
        FEdit.SetBounds(FSpliter + 1, 1, W - FSpliter - BW - 1, H - 2);
      end;
  end;
end;

procedure TCustomPropEdit.ClickReferButton(Sender: TObject);
begin
  if Assigned(FOnRefer) then
    FOnRefer(Self);
end;

procedure TCustomPropEdit.ComboBoxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Parent = nil then
    Exit;

  TWinControlAccess(Parent).KeyDown(Key, Shift);

  if (not FComboBox.ComboBox.DroppedDown) and (Shift = []) then
    case Key of
      VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT:
        Key := 0;
    end;
end;

procedure TCustomPropEdit.ComboBoxKeyPress(Sender: TObject; var Key: Char);
begin
  if Parent = nil then
    Exit;

  TWinControlAccess(Parent).KeyPress(Key);

  if (not FComboBox.ComboBox.DroppedDown) and (Word(Key) = VK_RETURN) then
    Key := #0;
end;
{
procedure TCustomPropEdit.ComboBoxMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  Key: Word;
begin
  if (Parent = nil) or FComboBox.ComboBox.DroppedDown then
    Exit;

  Key := VK_DOWN;
  TWinControlAccess(Parent).KeyDown(Key, Shift);
  Handled := True;
end;

procedure TCustomPropEdit.ComboBoxMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  Key: Word;
begin
  if (Parent = nil) or FComboBox.ComboBox.DroppedDown then
    Exit;

  Key := VK_UP;
  TWinControlAccess(Parent).KeyDown(Key, Shift);
  Handled := True;
end;
}
procedure TCustomPropEdit.EditChange(Sender: TObject);
begin
  FModified := True;
end;

procedure TCustomPropEdit.EditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Parent = nil then
    Exit;

  TWinControlAccess(Parent).KeyDown(Key, Shift);

  if Shift = [] then
    case Key of
      VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT:
        Key := 0;
    end
  else if (FStyle = psRefer) and (Shift = [ssAlt]) and (Key = VK_DOWN) then
    if Assigned(FOnRefer) then
      FOnRefer(Self);
end;

procedure TCustomPropEdit.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if Parent = nil then
    Exit;

  TWinControlAccess(Parent).KeyPress(Key);

  if Word(Key) = VK_RETURN then
    Key := #0;
end;

procedure TCustomPropEdit.EditKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Parent = nil then
    Exit;

  TWinControlAccess(Parent).KeyUp(Key, Shift);
end;
{
procedure TCustomPropEdit.EditMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  Key: Word;
begin
  if Parent = nil then
    Exit;

  Key := VK_DOWN;
  TWinControlAccess(Parent).KeyDown(Key, Shift);
  Handled := True;
end;

procedure TCustomPropEdit.EditMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var
  Key: Word;
begin
  if Parent = nil then
    Exit;

  Key := VK_UP;
  TWinControlAccess(Parent).KeyDown(Key, Shift);
  Handled := True;
end;
}
function TCustomPropEdit.GetDropDownCount: Integer;
begin
  Result := FComboBox.ComboBox.DropDownCount;
end;

function TCustomPropEdit.GetItemHeight: Integer;
begin
  FComboBox.ComboBox.HandleNeeded;
  Result := FComboBox.ComboBox.Height;
end;

function TCustomPropEdit.GetItems: TStrings;
begin
  Result := FComboBox.ComboBox.Items;
end;

function TCustomPropEdit.GetText: string;
begin
  if FStyle = psDropDown then
    Result := FComboBox.ComboBox.Text
  else
    Result := FEdit.Text;
end;

procedure TCustomPropEdit.SetBorderStyle(Value: TBorderStyle);
begin
  if FBorderStyle <> Value then
    begin
      FBorderStyle := Value;
      RecreateWnd;
    end;
end;

procedure TCustomPropEdit.SetDropDownCount(Value: Integer);
begin
  FComboBox.ComboBox.DropDownCount := Value;
end;

procedure TCustomPropEdit.SetItems(Value: TStrings);
var
  s: string;
begin
  s := FComboBox.ComboBox.Text;
  FComboBox.ComboBox.Items := Value;
  if FComboBox.ComboBox.Style = csDropDownList then
    FComboBox.ComboBox.ItemIndex := FComboBox.ComboBox.Items.IndexOf(s);
end;

procedure TCustomPropEdit.SetLabelCaption(Value: string);
begin
  if FLabelCaption <> Value then
    begin
      FLabelCaption := Value;
      Invalidate;
    end;
end;

procedure TCustomPropEdit.SetReadOnly(Value: Boolean);
begin
  if FReadOnly <> Value then
    begin
      FReadOnly := Value;
      if FReadOnly then
        begin
          TROComboBox(FComboBox.ComboBox).ReadOnly := True;
          FEdit.ReadOnly := True;
        end
      else
        begin
          TROComboBox(FComboBox.ComboBox).ReadOnly := False;
          FEdit.ReadOnly := False;
        end;
    end;
end;

procedure TCustomPropEdit.SetSpliter(Value: Integer);
begin
  if FSpliter <> Value then
    begin
      FSpliter := Value;
      AdjustEditControl;
      Invalidate;
    end;
end;

procedure TCustomPropEdit.SetStyle(Value: TPropEditStyle);
begin
  if FStyle <> Value then
    begin
      FStyle := Value;

      AdjustEditControl;

      case FStyle of
        psEdit:
          begin
            FEdit.Visible := True;
            FComboBox.Visible := False;
            FButton.Visible := False;
          end;
        psDropDown:
          begin
            FComboBox.Visible := True;
            FEdit.Visible := False;
            FButton.Visible := False;
          end
        else //psRefer:
          begin
            FEdit.Visible := True;
            FButton.Visible := True;
            FComboBox.Visible := False;
          end;
      end;

      Invalidate;
    end;
end;

procedure TCustomPropEdit.SetText(Value: string);
begin
  if FStyle = psDropDown then begin
    case  FComboBox.FComboBox.Style of
      csDropDown: FComboBox.ComboBox.Text := Value;
      csDropDownList: begin
        FComboBox.FComboBox.ItemIndex := FComboBox.FComboBox.Items.IndexOf(Value);
      end;
    end;
    //FComboBox.ComboBox.Text := Value;
    //FComboBox.ComboBox.SelText := Value;
  end else
    FEdit.Text := Value;
end;

procedure TCustomPropEdit.WMCaptureChanged(var Message: TMessage);
begin
  FButton.ReleaseCapture;
end;

procedure TCustomPropEdit.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 0;
end;

procedure TCustomPropEdit.WMNCHitTest(var Message: TWMNCHitTest);
var
  P: TPoint;
begin
  inherited;
  
  P := ScreenToClient(SmallPointToPoint(Message.Pos));

  if (P.x >= FSpliter - 2) and (P.x < FSpliter + 2) then
    Cursor := crHSplit
  else
    Cursor := crDefault;
end;

procedure TCustomPropEdit.CreateParams(var Params: TCreateParams);
const
  BorderStyles: array[TBorderStyle] of DWORD = (0, WS_BORDER);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    Style := Style or WS_CLIPCHILDREN or BorderStyles[FBorderStyle];
    if NewStyleControls and Ctl3D and (FBorderStyle = bsSingle) then
    begin
      Style := Style and not WS_BORDER;
      ExStyle := ExStyle or WS_EX_CLIENTEDGE;
    end;
  end;
end;

procedure TCustomPropEdit.CreateWnd;
begin
  inherited;
  AdjustEditControl;
end;

function TCustomPropEdit.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
var
  Key: Word;
begin
  if (Parent = nil) or FComboBox.ComboBox.DroppedDown then
    Result := False
  else
    begin
      Key := VK_DOWN;
      TWinControlAccess(Parent).KeyDown(Key, Shift);
      Result := True;
    end;
end;

function TCustomPropEdit.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
var
  Key: Word;
begin
  if (Parent = nil) or FComboBox.ComboBox.DroppedDown then
    Result := False
  else
    begin
      Key := VK_UP;
      TWinControlAccess(Parent).KeyDown(Key, Shift);
      Result := True;
    end;
end;

procedure TCustomPropEdit.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and (Shift = [ssLeft]) and (X >= 0) and (X < FSpliter) and (Parent <> nil) then
    Parent.Perform(WM_LBUTTONDOWN, MK_LBUTTON,
      Integer(PointToSmallPoint(Parent.ScreenToClient(ClientToScreen(Point(X, Y))))));
end;

procedure TCustomPropEdit.Paint;
var
  ARect: TRect;
  L: Integer;
begin
  with Canvas do
  begin
    ARect.Left   := 0;
    ARect.Top    := 0;
    ARect.Right  := FSpliter;
    ARect.Bottom := ClientHeight;
    Brush := Self.Brush;
    FillRect(ARect);

    Font := Self.Font;
    Font.Color := LeftColor;
    
    Brush.Style := bsClear;

    L := Length(FLabelCaption);
    if L > 0 then
      begin
        Inc(ARect.Left);
        DrawText(Handle, PChar(FLabelCaption), L, ARect,
          DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX or DT_END_ELLIPSIS);
      end;


    ARect.Left   := FSpliter;
    ARect.Right  := ClientWidth;
    Brush.Color := clWindow;
    FillRect(ARect);
  end;
end;

procedure TCustomPropEdit.Resize;
begin
  inherited;
  AdjustEditControl;
end;

function TCustomPropEdit.Focused: Boolean;
begin
  if FStyle = psDropDown then
    Result := FComboBox.Focused
  else
    Result := FEdit.Focused;
end;

procedure TCustomPropEdit.SetFocus;
begin
  inherited;
  if FStyle = psDropDown then
    FComboBox.SetFocus
  else
    FEdit.SetFocus;
end;

//TCustomPropListBox

constructor TCustomPropListBox.Create(AOwner: TComponent);
begin
  FPropEdit := TCustomPropEdit.Create(Self);
  with FPropEdit do
  begin
    ParentCtl3D := False;
    Ctl3D := True;
    OnRefer := Self.ClickReferButton;
  end;

  inherited Create(AOwner);

  FPropEdit.Parent := Self;
  FDropDownCount := 8;

  FSaveOnChange := FPropEdit.FComboBox.FComboBox.OnChange;
  FPropEdit.FComboBox.FComboBox.OnChange := CloseUp;
end;

destructor TCustomPropListBox.Destroy;
begin
  FPropEdit.Free;
  inherited Destroy;
end;

procedure TCustomPropListBox.ClickReferButton(Sender: TObject);
begin
  if Assigned(FOnRefer) then
    FOnRefer(Self, FItemIndex);
end;

function TCustomPropListBox.GetDropDownCount: Integer;
begin
  Result := FPropEdit.DropDownCount;
end;

function TCustomPropListBox.GetEditText: string;
begin
  if FItemIndex >= 0 then
    Result := FPropEdit.Text
  else
    Result := '';
end;

procedure TCustomPropListBox.SetDropDownCount(Value: Integer);
begin
  FPropEdit.DropDownCount := Value;
end;

procedure TCustomPropListBox.SetEditText(Value: string);
begin
  if FItemIndex >= 0 then
    FPropEdit.Text := Value;
end;

function TCustomPropListBox.CanChangeItemIndex: Boolean;
var
  n: TWinControl;
begin
  Result := True;
  if (FItemIndex >= 0) and FPropEdit.Modified then
    begin
      if Assigned(FOnCheck) then
        FOnCheck(Self, FItemIndex, Result);
      if Result then
        begin
          if Assigned(FOnUpdate)then
            FOnUpdate(Self, FItemIndex);
          FPropEdit.Modified := False;
          GetEditControl(FItemIndex, n);
        end;
    end;
end;

procedure TCustomPropListBox.ChangeItemIndex;
begin
  inherited;
  if Assigned(FOnChange) then
    FOnChange(Self);
  FPropEdit.SetFocus;
end;

procedure TCustomPropListBox.ChangeSpliter;
begin
  FPropEdit.Spliter := FSpliter;
  if Assigned(FOnChangeSpliter) then
    FOnChangeSpliter(Self);
end;

procedure TCustomPropListBox.CreateWnd;
begin
  inherited;
  InitItemHeight;
end;

procedure TCustomPropListBox.DrawItemText(Index: Integer; LRect, RRect: TRect; State: TOwnerDrawState);
begin
  if odSelected in State then
    Exit;
  inherited;
end;

procedure TCustomPropListBox.FreeEditControl(Control: TWinControl);
begin
  if FItemIndex < 0 then
    Control.Visible := False;
end;

procedure TCustomPropListBox.GetData(Index: Integer; var Item: TPropItem);
begin
  if Assigned(FOnData) then
    FOnData(Self, Index, Item)
  else
    with Item do
    begin
      LanelCaption := '';
      ValueCaption := '';
      Style := psEdit;
    end;
end;

procedure TCustomPropListBox.GetEditControl(Index: Integer; var Control: TWinControl);
var
  Item: TPropItem;
begin
  Control := FPropEdit;

  Item.LeftColor := clNone;
  Item.RightColor := clNone;
  GetData(Index, Item);

  with FPropEdit do
  begin
    Style := Item.Style;
    ReadOnly := Item.ReadOnly;
    LabelCaption := Item.LanelCaption;
    Text         := Item.ValueCaption;
    LeftColor    := Item.LeftColor;
    RightColor   := Item.RightColor;

    //Items.Clear;

    if (Style = psDropDown) and Assigned(FOnDropDown) then
      FOnDropDown(Self, FItemIndex, Items);
    if FComboBox.ComboBox.Style = csDropDownList then begin
      FComboBox.ComboBox.ItemIndex := FComboBox.ComboBox.Items.IndexOf(Item.ValueCaption);
    end;
    Spliter := Self.Spliter;

    Modified := False;
  end;
end;

procedure TCustomPropListBox.GetItemString(Index: Integer; var LeftCaption, RightCaption: string);
var
  Item: TPropItem;
begin
  GetData(Index, Item);

  LeftCaption  := Item.LanelCaption;
  RightCaption := Item.ValueCaption;
end;

procedure TCustomPropListBox.InitItemHeight;
begin
  if HandleAllocated then
    if FFlat then
      ItemHeight := FPropEdit.ItemHeight - 3
    else
      ItemHeight := FPropEdit.ItemHeight - 2
  else
    inherited;
end;

procedure TCustomPropListBox.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;

  if Key = VK_RETURN then
    CanChangeItemIndex;
end;

function TCustomPropListBox.CheckData: Boolean;
begin
  Result := CanChangeItemIndex;
end;
{
function TCustomPropListBox.Focused: Boolean;
begin
  Result := inherited Focused or ((EditControl <> nil) and EditControl.Focused);
end;
}

procedure TCustomPropListBox.CloseUp(Sender: TObject);
begin
  FSaveOnChange(Sender);
  CanChangeItemIndex;
end;

procedure TStackListBox.GetItemColor(Index: Integer; var LeftColor, RightColor: TColor);
begin
  LeftColor := clNone;
  RightColor := clNone;
end;

procedure TCustomPropListBox.GetItemColor(Index: Integer; var LeftColor,
  RightColor: TColor);
var
  Item: TPropItem;
begin
  Item.LeftColor := clNone;
  Item.RightColor := clNone;
  GetData(Index, Item);

  LeftColor  := Item.LeftColor;
  RightColor := Item.RightColor;
end;

procedure TCustomPropEdit.SetLeftColor(const Value: TColor);
begin
  if FLeftColor = Value then  exit;
  FLeftColor := Value;
  Invalidate;
end;

procedure TCustomPropEdit.SetRightColor(const Value: TColor);
begin
  if FRightColor = Value then exit;
  FRightColor := Value;
  Invalidate;
end;

end.
