unit gthread;
{$WARN SYMBOL_PLATFORM OFF}
interface

uses
  Windows,
  Classes, TextFileEncoding,
  OnigurumaClasses,
  NotePadSearch;

type
  TGrepThread = class(TThread)
  private
    { Private 錾 }
    FRegEx:widestring;
    FDir:widestring;
    FIgnoreCase:boolean;
    FUseRegEx:boolean;
    FSubDir:boolean;
    FFilter:wideString;
    FStop:boolean;
    SyncNumber:integer;
    SyncPath:widestring;
    SyncLine:widestring;
    FOniRegExp: TOniRegexp;
    //FFlag: byte;
    FSearchBM: TSearchBM;//}`XbhŎgƕ|̂Ő錾Ă
    FParent: TObject;
    FFileCode: TFileCode;

    procedure GrepIn(const pathname:widestring); 
    procedure DoGrep(const pathname:widestring);
  protected
    procedure Execute; override;
    procedure safe1;
  public
    constructor Create(AParent: TObject; const RegEx:widestring;
      const PathName:widestring; const Filter:widestring;
      IgnoreCase, useRegEx, SubDir: boolean;
      FileCode: TFileCode);
    destructor Destroy;override;
  end;


implementation
uses
  sysutils, grepbox, main, wsFileOp;


{: 
  قȂXbhL VCL ܂ CLX ̃\bh/֐/
  vpeBʂ̃Xbh̒爵ꍇAr̖肪
  ܂B

  CXbh̏LIuWFNgɑ΂Ă Synchronize
  \bhgł܂B̃IuWFNgQƂ邽
  ̃\bhXbhNXɒǉASynchronize \bh
  Ƃēn܂B

  Ƃ΁AUpdateCaption \bhȉ̂悤ɒ`A

    procedure TGrepThread.UpdateCaption;
    begin
      Form1.Caption := 'TGrepThread Xbh珑܂';
    end;

  Execute \bh̒ Synchronize \bhɓnƂŃC
  XbhL Form1  Caption vpeBSɕ
  Xł܂B

      Synchronize(UpdateCaption);
}

{ TGrepThread }

constructor TGrepThread.Create(AParent: TObject; const RegEx, PathName,Filter: widestring; IgnoreCase,
  useRegEx, SubDir: boolean;FileCode: TFileCode);
begin
  inherited Create(true);
  FParent := AParent;
  FRegEx := RegEx;
  Fdir := PathName;
  FIgnoreCase := IgnoreCase;
  FUseRegEx := useRegEx;
  FSubDir := SubDir;
  FFilter:=Filter;
  FStop:=false;
  FreeOnTerminate := false;
  FOniRegExp := TOniRegexp.Create;
  //FRegExpr.Expression := RegEx;
  //FRegExpr.ModifierI := IgnoreCase;
  //FRegExpr.ModifierR := false;
  //FRegExpr.ModifierS := false;
//  FRegExpr.ModifierG := isShort;
  //FRegExpr.ModifierM := true;
  if FUseRegEx then FOniRegExp.Compile(RegEx, IgnoreCase);
  //if IgnoreCase then FFlag := FWS_DOWN_IGNORECASE else FFlag := FWS_DOWN;
  FSearchBM := TSearchBM.Create;
  FSearchBM.IgCase := IgnoreCase;
  FSearchBM.SubStr := RegEx;
  FFileCode := FileCode;
end;

destructor TGrepThread.Destroy;
begin
  if Assigned(FOniRegExp) then FOniRegExp.Free;
  if Assigned(FSearchBM) then FSearchBM.Free;
  inherited;
end;

procedure TGrepThread.DoGrep(const pathname:widestring);
var
  sr:TSearchRec;
  tempdir:widestring;
begin

  if pathname[length(pathname)]='\' then tempdir:=pathname else
    tempdir:=pathname+'\';
  if FindFirst(tempdir+FFilter,faAnyFile, sr) = 0 then begin
    try
      repeat
        if Terminated or Suspended then begin
          //FindClose(sr);
          break;
        end;
        if (sr.Attr and ($00000008{faVolumeID} or faDirectory or faSysFile))=0 then
          GrepIn(tempdir+sr.Name);
      until FindNext(sr) <> 0;
    finally
      FindClose(sr);
    end;
  end;
  if FSubDir and(not Terminated) then begin
    if FindFirst(tempdir+'*.*',faDirectory, sr) = 0 then begin
      try
        repeat
        if Terminated or Suspended then begin
          //FindClose(sr);
          break;
        end;
          if (sr.Name <> '.')and(sr.Name <> '..')then begin
            DoGrep(tempdir+sr.Name);
          end;
        until FindNext(sr) <> 0;
      finally
        FindClose(sr);
      end;
    end;
  end;
end;

procedure TGrepThread.Execute;
begin
  DoGrep(FDir);
end;

procedure TGrepThread.GrepIn(const pathname: widestring);
var
  targetW, ws: widestring;
  i, j: integer;
  code: TFileCode;
  e, e2: boolean;
  loop1: boolean;
  ALineNum, AStart, ALast, ALength: integer;
  TargetLen: integer;
begin
  if (FFileCode = fcNone) and (not GetHeaderIsText(pathname)) then exit;
  code := FFileCode;
  ws := LoadFromFile(pathname, code, false, e, e2);
  TargetLen := Length(ws);
  SetLength(targetW, TargetLen);
  i := 1;
  j := 1;
  while i <= TargetLen do begin
    case ws[i] of
      #13: begin
        targetW[j] := #10;
        inc(j);
        inc(i);
        if (i <= TargetLen) and (ws[i] = #10) then inc(i);
      end;
      else begin
        targetW[j] := ws[i];
        inc(j);
        inc(i);
      end;
    end;
  end;
  TargetLen := j - 1;
  SetLength(targetW, TargetLen);
  i := 0;
  ALineNum := 0;
  AStart := 1;
  ALast := 1;
  try
    FOniRegExp.InputString := PWideChar(targetW);
    if (not FUseRegEx) or (FOniRegExp.Compiled and FOniRegExp.Exec(1, TargetLen, TargetLen, true, false)) then
    repeat
      if Terminated or Suspended then exit;
      if FUseRegEx then
        i := FOniRegExp.MatchPos
      else
        i := FSearchBM.Search(PWChar(targetW), Length(targetW), i, Length(targetW), true);
      if i > 0 then begin
        if ALast > i then begin
        end else begin
          repeat
            if Terminated or Suspended then exit;
            if targetW[ALast] = #10 then begin
              if ALast < Length(targetW) then begin
                inc(ALineNum);
                AStart := ALast + 1;
              end;
            end;
            inc(ALast);
          until ALast > i;
          while (ALast < Length(targetW)) do begin
            if targetW[ALast] = #10 then begin
              break;
            end;
            inc(ALast);
          end;
          ALength := ALast - AStart;
          while (targetW[AStart + ALength - 1] = #10) do dec(ALength);
          SyncLine := Copy(targetW, AStart, ALength);
          SyncNumber := ALineNum;
          SyncPath := pathname;
          if Terminated or Suspended then exit;
          Synchronize(safe1);
        end;
      end;
      if FUseRegEx then begin
        loop1 := FOniRegExp.Exec(i + 1, TargetLen, TargetLen, true, false);
      end else loop1 := i > 0;
    until not loop1;
  except
  end;

end;


procedure TGrepThread.safe1;
begin
  if Terminated or Suspended then exit;
  TGrepForm(FParent).AddNewLine(SyncPath,SyncLine,SyncNumber);
end;


end.
