unit wNotePad;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls,
  NotePadView, OnigurumaClasses;

type
  TwNotePad = class(TNotePad)
  private
    procedure WMSetFocus(var Msg: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Msg: TWMKillFocus); message WM_KILLFOCUS;
    procedure SetSearchWithRegEx(Value: boolean);
  protected
    FSearchRE: boolean;
    procedure SearchHighlight(Value: integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
    property SearchWithRegEx: boolean read FSearchRE write SetSearchWithRegEx;
  published
    property OnEnter;
  end;

var
  FocusedNotePad: TwNotePad;
  LastNotePad: TwNotePad;

var
  FOniRegExp: TOniRegexp;
//܂@̂
  FRegReplaceText: WideString;
  FReplace1st: boolean;

procedure Register;

implementation

uses Math, NotePadClasses, NotePadConsts, ParserConsts;

procedure Register;
begin
  RegisterComponents('Samples', [TwNotePad]);
end;

{ TwNotePad }

constructor TwNotePad.Create(AOwner: TComponent);
begin
  inherited;
  FSearchRE := false;
end;

destructor TwNotePad.Destroy;
begin
  if LastNotePad = self then LastNotePad := nil;
//  if FocusedNotePad = self then FocusedNotePad := nil;
//  if Assigned(ViewChanged) then ViewChanged(self);
  inherited;
end;

procedure TwNotePad.SearchHighlight(Value: integer);
var
  ALine: PLineData;
  Start1, End1, hitlen, Len1: integer;
  p: integer;
  i: integer;
begin
  if FSearchRE then begin
    if (Length(SearchText) = 0) or (not FOniRegExp.Compiled) or
    ((FOptions.ColorHighlight = clNone) and (FOptions.StyleHighlight = [])) then exit;
    ALine := FStr[Value];
    Start1 := ALine.Start;
    End1 := Start1 + ALine.Length;
    //s܂F͂Ȃ
    //if (Value > 0) and (FStr[Value - 1].LineEnd = leWrap) then begin
    //  dec(Value);
    //  ALine := FStr[Value];
    //end;
    p := ALine.Start;
    FOniRegExp.InputString := FStr.InternalSB.ToPointer(0);
    len1 := Min(TextLength, End1 + 1);
    while FOniRegExp.Exec(p + 1, {TextLength}Len1, End1, true, false) do begin
      p := FOniRegExp.MatchPos;
      hitlen := FOniRegExp.MatchLen;
      if p - 1 - Start1 + hitlen - 1 >= 0 then begin
        for i := 0 to hitlen - 1 do
          if p - 1 - Start1 + i >= 0 then begin
            if p - 1 - Start1 + i >= ALine.Length then begin
              p := 0;
              break;
            end else LineTokens[p - Start1 - 1 + i] := toHighlight;
          end;
      end;
      if p = 0 then break;
    end;
  end else inherited;
end;

procedure TwNotePad.SetSearchWithRegEx(Value: boolean);
begin
  FSearchRE := Value;
  Invalidate;
  DoViewChanged;
end;

procedure TwNotePad.WMKillFocus(var Msg: TWMKillFocus);
begin
  inherited;
  FocusedNotePad := nil;
  if Assigned(ViewChanged) then ViewChanged(self);
end;

procedure TwNotePad.WMSetFocus(var Msg: TWMSetFocus);
begin
  inherited;
  if Focused then begin
    FocusedNotePad := Self;
    LastNotePad := Self;
   end else FocusedNotePad := nil;
  if Assigned(ViewChanged) then ViewChanged(self);
end;

end.
