unit wsMemIni;

interface

uses Windows, IniFiles;

type
  TMemIniFileW = class(TMemIniFile)
  public
    function ReadStringW(const Section, Ident, Default: WideString): widestring;
    procedure UpdateFile; override;
    procedure WriteStringW(const Section, Ident, Value: wideString);
  end;

implementation

procedure TMemIniFileW.UpdateFile;
begin
  WriteString('UNICODE', '+' , '--- ̍s͍폜ViCł ---');
  inherited UpdateFile;
end;

function TMemIniFileW.ReadStringW(const Section, Ident,
  Default: WideString): widestring;
var
  u7: AnsiString;
  i: integer;
begin
  u7 := AnsiString(ReadString(Section, Ident, Default));
  if WideString(u7) = Default then begin
    Result := Default;
    exit;
  end;
  i := MultiByteToWideChar(CP_UTF7, 0, PAnsiChar(u7), Length(u7), nil, 0);
  if (i > 0)and(i <> Length(u7)) then begin
    SetLength(Result,i);
    MultiByteToWideChar(CP_UTF7,0,pansichar(u7),Length(u7),pwidechar(result),length(result));
  end else
    Result := u7;
end;

procedure TMemIniFileW.WriteStringW(const Section, Ident,
  Value: WideString);
var
  u7: AnsiString;
begin
  SetLength(u7, WideCharToMultiByte(CP_UTF7, 0, PWChar(Value), Length(Value), nil, 0, nil, nil));
  WideCharToMultiByte(CP_UTF7, 0, PWChar(Value), Length(Value), PAnsiChar(u7), Length(u7), nil, nil);
  WriteString(Section, Ident, u7);
end;

end.
